// 
// File:          sidlx_rmi_SimHandle.hxx
// Symbol:        sidlx.rmi.SimHandle-v0.1
// Symbol Type:   class
// Babel Version: 2.0.0 (Revision: 7437  trunk)
// Description:   Client-side glue code for sidlx.rmi.SimHandle
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_sidlx_rmi_SimHandle_hxx
#define included_sidlx_rmi_SimHandle_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace sidlx { 
  namespace rmi { 

    class SimHandle;
  } // end namespace rmi
} // end namespace sidlx

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::sidlx::rmi::SimHandle >;
}
// 
// Forward declarations for method dependencies.
// 
namespace sidl { 

  class RuntimeException;
} // end namespace sidl

namespace sidl { 
  namespace io { 

    class Serializable;
  } // end namespace io
} // end namespace sidl

namespace sidl { 
  namespace rmi { 

    class Invocation;
  } // end namespace rmi
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#include <stdint.h>
#ifndef included_sidlx_rmi_SimHandle_IOR_h
#include "sidlx_rmi_SimHandle_IOR.h"
#endif
#ifndef included_sidl_BaseClass_hxx
#include "sidl_BaseClass.hxx"
#endif
#ifndef included_sidl_rmi_InstanceHandle_hxx
#include "sidl_rmi_InstanceHandle.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace sidlx { 
  namespace rmi { 

    /**
     * Symbol "sidlx.rmi.SimHandle" (version 0.1)
     * 
     * implementation of InstanceHandle using the Simhandle Protocol (written by Jim)
     */
    class SimHandle: public virtual ::sidl::BaseClass, public virtual 
      ::sidl::rmi::InstanceHandle {

      //////////////////////////////////////////////////
      // 
      // Special methods for throwing exceptions
      // 

    private:
      static 
      void
      throwException0(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
      ;
    public:
      typedef struct sidlx_rmi_SimHandle__object ior_t;
      typedef struct sidlx_rmi_SimHandle__external ext_t;
      typedef struct sidlx_rmi_SimHandle__sepv sepv_t;


      //////////////////////////////////////////////////
      // 
      // User Defined Methods
      // 

    public:

      /**
       * Set a cookie.  All RMI's made by this protocol will use this cookie
       * after it is set.  This should be called BEFORE any calls are made
       * by this protocol.  If it is called WHILE calls are being made on
       * another thread, the results are undefined.
       */
      static void
      setCookie (
        /* in rarray[len] */char* cookie,
        /* in */int32_t len
      )
      ;


      /**
       * Set a cookie.  All RMI's made by this protocol will use this cookie
       * after it is set.  This should be called BEFORE any calls are made
       * by this protocol.  If it is called WHILE calls are being made on
       * another thread, the results are undefined.
       */
      static void
      setCookie (
        /* in rarray[len] */const ::sidl::array<char>& cookie
      )
      ;



      /**
       *  initialize a connection (intended for use by the
       * ProtocolFactory, (see above).  This should parse the url and
       * do everything necessary to create the remote object.
       */
      bool
      initCreate (
        /* in */const ::std::string& url,
        /* in */const ::std::string& typeName
      )
      ;


      /**
       * initialize a connection (intended for use by the ProtocolFactory) 
       * This should parse the url and do everything necessary to connect 
       * to a remote object.
       */
      bool
      initConnect (
        /* in */const ::std::string& url,
        /* in */const ::std::string& typeName,
        /* in */bool ar
      )
      ;


      /**
       *  Get a connection specifically for the purpose for requesting a 
       * serialization of a remote object (intended for use by the
       * ProtocolFactory, (see above).  This should parse the url and
       * request the object.  It should return a deserializer..
       */
      ::sidl::io::Serializable
      initUnserialize (
        /* in */const ::std::string& url
      )
      ;


      /**
       *  return the short name of the protocol 
       */
      ::std::string
      getProtocol() ;

      /**
       *  return the object ID for the remote object
       */
      ::std::string
      getObjectID() ;

      /**
       *  
       * return the full URL for this object, takes the form: 
       * protocol://serviceID/objectID (where serviceID would = server:port 
       * on TCP/IP)
       * So usually, like this: protocol://server:port/objectID
       */
      ::std::string
      getObjectURL() ;

      /**
       *  create a serializer handle to invoke the named method 
       */
      ::sidl::rmi::Invocation
      createInvocation (
        /* in */const ::std::string& methodName
      )
      ;


      /**
       *  
       * closes the connection (called by the destructor, if not done
       * explicitly) returns true if successful, false otherwise
       * (including subsequent calls)
       */
      bool
      close() ;

      //////////////////////////////////////////////////
      // 
      // End User Defined Methods
      // (everything else in this file is specific to
      //  Babel's C++ bindings)
      // 

      // default constructor
      SimHandle() { }
      // static constructor
      static ::sidlx::rmi::SimHandle _create();


#ifdef WITH_RMI

      // RMI constructor
      static ::sidlx::rmi::SimHandle _create( /*in*/ const std::string& url );

      // RMI connect
      static inline ::sidlx::rmi::SimHandle _connect( /*in*/ const std::string& 
        url ) { 
        return _connect(url, true);
      }

      // RMI connect 2
      static ::sidlx::rmi::SimHandle _connect( /*in*/ const std::string& url, 
        /*in*/ const bool ar  );


#endif /*WITH_RMI*/

      // default destructor
      virtual ~SimHandle () { }

      // copy constructor
      SimHandle ( const SimHandle& original );

      // assignment operator
      SimHandle& operator= ( const SimHandle& rhs );


      protected:
      // Internal data wrapping method
      static ior_t*  _wrapObj(void* private_data);


      public:
      // conversion from ior to C++ class
      SimHandle ( SimHandle::ior_t* ior );

      // Alternate constructor: does not call addRef()
      // (sets d_weak_reference=isWeak)
      // For internal use by Impls (fixes bug#275)
      SimHandle ( SimHandle::ior_t* ior, bool isWeak );

      inline ior_t* _get_ior() const throw() {
        return reinterpret_cast< ior_t*>(d_self);
      }

      inline void _set_ior( ior_t* ptr ) throw () { 
        d_self = reinterpret_cast< void*>(ptr);

        if( ptr != NULL ) {
          sidl_rmi_InstanceHandle_IORCache = &((
            *ptr).d_sidl_rmi_instancehandle);
        } else {
          sidl_rmi_InstanceHandle_IORCache = NULL;
        }
      }

      virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                     const ::std::type_info &argtype );

      bool _is_nil() const throw () { return (d_self==0); }

      bool _not_nil() const throw () { return (d_self!=0); }

      bool operator !() const throw () { return (d_self==0); }

      static inline const char * type_name() throw () { return 
        "sidlx.rmi.SimHandle";}

      static struct sidlx_rmi_SimHandle__object* _cast(const void* src);

      // execute member function by name
      void _exec(const std::string& methodName,
                 ::sidl::rmi::Call& inArgs,
                 ::sidl::rmi::Return& outArgs);
      // exec static member function by name
      static void _sexec(const std::string& methodName,
                         ::sidl::rmi::Call& inArgs,
                         ::sidl::rmi::Return& outArgs);


      /**
       * Get the URL of the Implementation of this object (for RMI)
       */
      ::std::string
      _getURL() // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable method hooks invocation.
       */
      void
      _set_hooks (
        /* in */bool enable
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Static Method to enable/disable method hooks invocation.
       */
      static void
      _set_hooks_static (
        /* in */bool enable
      )
      // throws:
      //    ::sidl::RuntimeException
      ;

      // return true iff object is remote
      bool _isRemote() const { 
        ior_t* self = const_cast<ior_t*>(_get_ior() );
        struct sidl_BaseInterface__object *throwaway_exception;
        return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == TRUE;
      }

      // return true iff object is local
      bool _isLocal() const {
        return !_isRemote();
      }

    protected:
      // Pointer to external (DLL loadable) symbols (shared among instances)
      static const ext_t * s_ext;

      // Global cache for _get_sepv()
      static sepv_t *_sepv;

    public:
      static const ext_t * _get_ext() throw ( ::sidl::NullIORException );

      static const sepv_t * _get_sepv() {
        if(!_sepv) _sepv = (*(_get_ext()->getStaticEPV))();
        return _sepv;
      }

    }; // end class SimHandle
  } // end namespace rmi
} // end namespace sidlx

extern "C" {


#pragma weak sidlx_rmi_SimHandle__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct sidlx_rmi_SimHandle__object*
  sidlx_rmi_SimHandle__connectI(const char * url, sidl_bool ar, struct 
    sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::sidlx::rmi::SimHandle > {
    typedef array< ::sidlx::rmi::SimHandle > cxx_array_t;
    typedef ::sidlx::rmi::SimHandle cxx_item_t;
    typedef struct sidlx_rmi_SimHandle__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct sidlx_rmi_SimHandle__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::sidlx::rmi::SimHandle > > iterator;
    typedef const_array_iter< array_traits< ::sidlx::rmi::SimHandle > > 
      const_iterator;
  };

  // array specialization
  template<>
  class array< ::sidlx::rmi::SimHandle >: public interface_array< array_traits< 
    ::sidlx::rmi::SimHandle > > {
  public:
    typedef interface_array< array_traits< ::sidlx::rmi::SimHandle > > Base;
    typedef array_traits< ::sidlx::rmi::SimHandle >::cxx_array_t          
      cxx_array_t;
    typedef array_traits< ::sidlx::rmi::SimHandle >::cxx_item_t           
      cxx_item_t;
    typedef array_traits< ::sidlx::rmi::SimHandle >::ior_array_t          
      ior_array_t;
    typedef array_traits< ::sidlx::rmi::SimHandle >::ior_array_internal_t 
      ior_array_internal_t;
    typedef array_traits< ::sidlx::rmi::SimHandle >::ior_item_t           
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct sidlx_rmi_SimHandle__array* src = 0) : Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::sidlx::rmi::SimHandle >&src) : Base(src) {}

    /**
     * assignment
     */
    array< ::sidlx::rmi::SimHandle >&
    operator =( const array< ::sidlx::rmi::SimHandle >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#ifndef included_sidl_io_Serializable_hxx
#include "sidl_io_Serializable.hxx"
#endif
#ifndef included_sidl_rmi_Invocation_hxx
#include "sidl_rmi_Invocation.hxx"
#endif
#endif
