// 
// File:          sidlx_rmi_SimpleOrb.hxx
// Symbol:        sidlx.rmi.SimpleOrb-v0.1
// Symbol Type:   class
// Babel Version: 2.0.0 (Revision: 7437  trunk)
// Description:   Client-side glue code for sidlx.rmi.SimpleOrb
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_sidlx_rmi_SimpleOrb_hxx
#define included_sidlx_rmi_SimpleOrb_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace sidlx { 
  namespace rmi { 

    class SimpleOrb;
  } // end namespace rmi
} // end namespace sidlx

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::sidlx::rmi::SimpleOrb >;
}
// 
// Forward declarations for method dependencies.
// 
namespace sidl { 

  class RuntimeException;
} // end namespace sidl

namespace sidl { 
  namespace io { 

    class Serializable;
  } // end namespace io
} // end namespace sidl

namespace sidlx { 
  namespace rmi { 

    class Socket;
  } // end namespace rmi
} // end namespace sidlx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#include <stdint.h>
#ifndef included_sidlx_rmi_SimpleOrb_IOR_h
#include "sidlx_rmi_SimpleOrb_IOR.h"
#endif
#ifndef included_sidlx_rmi_SimpleServer_hxx
#include "sidlx_rmi_SimpleServer.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace sidlx { 
  namespace rmi { 

    /**
     * Symbol "sidlx.rmi.SimpleOrb" (version 0.1)
     * 
     * A simple example orb, using the simhandle protocol (written by Jim)
     */
    class SimpleOrb: public virtual ::sidlx::rmi::SimpleServer {

      //////////////////////////////////////////////////
      // 
      // Special methods for throwing exceptions
      // 

    private:
      static 
      void
      throwException0(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
      ;
    public:
      typedef struct sidlx_rmi_SimpleOrb__object ior_t;
      typedef struct sidlx_rmi_SimpleOrb__external ext_t;
      typedef struct sidlx_rmi_SimpleOrb__sepv sepv_t;


      //////////////////////////////////////////////////
      // 
      // User Defined Methods
      // 

    public:

      /**
       * Set a cookie.  All incoming RMI's without matching cookie are 
       * discarded.  setCookie must be called before run, if not, the results
       * are undefined. 
       */
      void
      setCookie (
        /* in rarray[len] */char* cookie,
        /* in */int32_t len
      )
      ;


      /**
       * Set a cookie.  All incoming RMI's without matching cookie are 
       * discarded.  setCookie must be called before run, if not, the results
       * are undefined. 
       */
      void
      setCookie (
        /* in rarray[len] */const ::sidl::array<char>& cookie
      )
      ;



      /**
       * If a cookie has been set, any RMI that does not authenticate with 
       * the cookie will be discarded.  setNumSecurityRetries sets a maximum 
       * number of times the Orb will discard RMIs before shutting down.
       * In other words, if more than 'retries' unauthenticateable RMIs are 
       * received, the Orb shutsdown on abnormally with an error message.
       * This call can be called before or after setCookie, but if a cookie
       * is not set, this call has no functional effect.  
       * setNumSecurityRetries  must be called before run, if not, the results
       * are undefined. 
       */
      void
      setNumSecurityRetries (
        /* in */int32_t retries
      )
      ;

      /**
       * user defined non-static method
       */
      void
      serviceRequest (
        /* in */const ::sidlx::rmi::Socket& sock
      )
      ;


      /**
       * Get the full URL for exporting objects
       */
      ::std::string
      getServerURL (
        /* in */const ::std::string& objID
      )
      ;


      /**
       * Needed by Babel to determine if a url points to a local or remote object
       * users should never need this.  Returns the objectID if is local, Null otherwise. 
       */
      ::std::string
      isLocalObject (
        /* in */const ::std::string& url
      )
      ;


      /**
       * Get the short name of the protocol this ORB supports
       */
      ::std::string
      getProtocol() ;

      /**
       * This gets an array of logged exceptions.  If an exception can
       * not be thrown back to the caller, we log it with the Server.  This 
       * gets the array of all those exceptions.
       * THIS IS SOMETHING OF A TEST! THIS MAY CHANGE!
       */
      ::sidl::array< ::sidl::io::Serializable>
      getExceptions() ;

      //////////////////////////////////////////////////
      // 
      // End User Defined Methods
      // (everything else in this file is specific to
      //  Babel's C++ bindings)
      // 

      // default constructor
      SimpleOrb() { }
      // static constructor
      static ::sidlx::rmi::SimpleOrb _create();


#ifdef WITH_RMI

      // RMI constructor
      static ::sidlx::rmi::SimpleOrb _create( /*in*/ const std::string& url );

      // RMI connect
      static inline ::sidlx::rmi::SimpleOrb _connect( /*in*/ const std::string& 
        url ) { 
        return _connect(url, true);
      }

      // RMI connect 2
      static ::sidlx::rmi::SimpleOrb _connect( /*in*/ const std::string& url, 
        /*in*/ const bool ar  );


#endif /*WITH_RMI*/

      // default destructor
      virtual ~SimpleOrb () { }

      // copy constructor
      SimpleOrb ( const SimpleOrb& original );

      // assignment operator
      SimpleOrb& operator= ( const SimpleOrb& rhs );


      protected:
      // Internal data wrapping method
      static ior_t*  _wrapObj(void* private_data);


      public:
      // conversion from ior to C++ class
      SimpleOrb ( SimpleOrb::ior_t* ior );

      // Alternate constructor: does not call addRef()
      // (sets d_weak_reference=isWeak)
      // For internal use by Impls (fixes bug#275)
      SimpleOrb ( SimpleOrb::ior_t* ior, bool isWeak );

      inline ior_t* _get_ior() const throw() {
        return reinterpret_cast< ior_t*>(d_self);
      }

      inline void _set_ior( ior_t* ptr ) throw () { 
        d_self = reinterpret_cast< void*>(ptr);

        if( ptr != NULL ) {
          sidl_rmi_ServerInfo_IORCache = &((
            *ptr).d_sidlx_rmi_simpleserver.d_sidl_rmi_serverinfo);
        } else {
          sidl_rmi_ServerInfo_IORCache = NULL;
        }
      }

      virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                     const ::std::type_info &argtype );

      bool _is_nil() const throw () { return (d_self==0); }

      bool _not_nil() const throw () { return (d_self!=0); }

      bool operator !() const throw () { return (d_self==0); }

      static inline const char * type_name() throw () { return 
        "sidlx.rmi.SimpleOrb";}

      static struct sidlx_rmi_SimpleOrb__object* _cast(const void* src);

      // execute member function by name
      void _exec(const std::string& methodName,
                 ::sidl::rmi::Call& inArgs,
                 ::sidl::rmi::Return& outArgs);

      /**
       * Get the URL of the Implementation of this object (for RMI)
       */
      ::std::string
      _getURL() // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable method hooks invocation.
       */
      void
      _set_hooks (
        /* in */bool enable
      )
      // throws:
      //    ::sidl::RuntimeException
      ;

      // return true iff object is remote
      bool _isRemote() const { 
        ior_t* self = const_cast<ior_t*>(_get_ior() );
        struct sidl_BaseInterface__object *throwaway_exception;
        return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == TRUE;
      }

      // return true iff object is local
      bool _isLocal() const {
        return !_isRemote();
      }

    protected:
      // Pointer to external (DLL loadable) symbols (shared among instances)
      static const ext_t * s_ext;

      // Global cache for _get_sepv()
      static sepv_t *_sepv;

    public:
      static const ext_t * _get_ext() throw ( ::sidl::NullIORException );

    }; // end class SimpleOrb
  } // end namespace rmi
} // end namespace sidlx

extern "C" {


#pragma weak sidlx_rmi_SimpleOrb__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct sidlx_rmi_SimpleOrb__object*
  sidlx_rmi_SimpleOrb__connectI(const char * url, sidl_bool ar, struct 
    sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::sidlx::rmi::SimpleOrb > {
    typedef array< ::sidlx::rmi::SimpleOrb > cxx_array_t;
    typedef ::sidlx::rmi::SimpleOrb cxx_item_t;
    typedef struct sidlx_rmi_SimpleOrb__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct sidlx_rmi_SimpleOrb__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::sidlx::rmi::SimpleOrb > > iterator;
    typedef const_array_iter< array_traits< ::sidlx::rmi::SimpleOrb > > 
      const_iterator;
  };

  // array specialization
  template<>
  class array< ::sidlx::rmi::SimpleOrb >: public interface_array< array_traits< 
    ::sidlx::rmi::SimpleOrb > > {
  public:
    typedef interface_array< array_traits< ::sidlx::rmi::SimpleOrb > > Base;
    typedef array_traits< ::sidlx::rmi::SimpleOrb >::cxx_array_t          
      cxx_array_t;
    typedef array_traits< ::sidlx::rmi::SimpleOrb >::cxx_item_t           
      cxx_item_t;
    typedef array_traits< ::sidlx::rmi::SimpleOrb >::ior_array_t          
      ior_array_t;
    typedef array_traits< ::sidlx::rmi::SimpleOrb >::ior_array_internal_t 
      ior_array_internal_t;
    typedef array_traits< ::sidlx::rmi::SimpleOrb >::ior_item_t           
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct sidlx_rmi_SimpleOrb__array* src = 0) : Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::sidlx::rmi::SimpleOrb >&src) : Base(src) {}

    /**
     * assignment
     */
    array< ::sidlx::rmi::SimpleOrb >&
    operator =( const array< ::sidlx::rmi::SimpleOrb >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#ifndef included_sidl_io_Serializable_hxx
#include "sidl_io_Serializable.hxx"
#endif
#ifndef included_sidlx_rmi_Socket_hxx
#include "sidlx_rmi_Socket.hxx"
#endif
#endif
