// 
// File:          sidlx_rmi_SimpleServer.hxx
// Symbol:        sidlx.rmi.SimpleServer-v0.1
// Symbol Type:   class
// Babel Version: 2.0.0 (Revision: 7437  trunk)
// Description:   Client-side glue code for sidlx.rmi.SimpleServer
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_sidlx_rmi_SimpleServer_hxx
#define included_sidlx_rmi_SimpleServer_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace sidlx { 
  namespace rmi { 

    class SimpleServer;
  } // end namespace rmi
} // end namespace sidlx

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::sidlx::rmi::SimpleServer >;
}
// 
// Forward declarations for method dependencies.
// 
namespace sidl { 

  class RuntimeException;
} // end namespace sidl

namespace sidlx { 
  namespace rmi { 

    class Socket;
  } // end namespace rmi
} // end namespace sidlx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#include <stdint.h>
#ifndef included_sidlx_rmi_SimpleServer_IOR_h
#include "sidlx_rmi_SimpleServer_IOR.h"
#endif
#ifndef included_sidl_BaseClass_hxx
#include "sidl_BaseClass.hxx"
#endif
#ifndef included_sidl_rmi_ServerInfo_hxx
#include "sidl_rmi_ServerInfo.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace sidlx { 
  namespace rmi { 

    /**
     * Symbol "sidlx.rmi.SimpleServer" (version 0.1)
     * 
     * A multi-threaded base class for simple network servers.
     * 
     * This server takes the following flags:
     * 1: verbose output (to stdout)
     */
    class SimpleServer: public virtual ::sidl::BaseClass, public virtual 
      ::sidl::rmi::ServerInfo {

      //////////////////////////////////////////////////
      // 
      // Special methods for throwing exceptions
      // 

    private:
      static 
      void
      throwException0(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
      ;
    public:
      typedef struct sidlx_rmi_SimpleServer__object ior_t;
      typedef struct sidlx_rmi_SimpleServer__external ext_t;
      typedef struct sidlx_rmi_SimpleServer__sepv sepv_t;


      //////////////////////////////////////////////////
      // 
      // User Defined Methods
      // 

    public:

      /**
       * Set the maximum size of the client thread pool.
       * (default = 1024)
       */
      void
      setMaxThreadPool (
        /* in */int32_t max
      )
      ;


      /**
       * request a specific port number
       * returns true iff request is satisfied
       */
      bool
      requestPort (
        /* in */int32_t port
      )
      ;


      /**
       * Request the minimum available port in 
       * a range.  Returns true iff request is satisfied
       */
      bool
      requestPort (
        /* in */int32_t minport,
        /* in */int32_t maxport
      )
      ;


      /**
       * Request a specific port number.
       * Accepts only local connections.
       * Returns true iff request is satisfied.
       */
      bool
      requestLocalPort (
        /* in */int32_t port
      )
      ;


      /**
       * Request the minimum available port in 
       * a range.  Returns true iff request is satisfied.
       * Accepts only local connections.
       */
      bool
      requestLocalPort (
        /* in */int32_t minport,
        /* in */int32_t maxport
      )
      ;


      /**
       * get the port that this Server is bound to
       */
      int32_t
      getPort() ;

      /**
       * get the network name of this computer
       */
      ::std::string
      getServerName() ;

      /**
       * get the full URL for exporting objects
       */
      ::std::string
      getServerURL (
        /* in */const ::std::string& objID
      )
      ;


      /**
       * run the server (must have port specified first), if a threaded server,
       * returns the tid of the server thread for joining.
       */
      int64_t
      run() ;

      /**
       * Cleanly shutdown the orb.  Method blocks until orb is fully shutdown.
       */
      void
      shutdown() ;

      /**
       * Starts the shutodwn process, but does not wait for shutdown to 
       * complete before returning.
       */
      void
      shutdownNoWait() ;

      /**
       * Check if the ORB is running.  NOT REALLY THREAD SAFE.  DON'T TRY TO USE
       * THIS WHEN THREAD SAFETY IS AN ISSUE.
       */
      bool
      isRunning() ;

      /**
       * invoked by child processes, takes a connected socket, ready for
       * communications. 
       */
      void
      serviceRequest (
        /* in */const ::sidlx::rmi::Socket& sock
      )
      ;


      //////////////////////////////////////////////////
      // 
      // End User Defined Methods
      // (everything else in this file is specific to
      //  Babel's C++ bindings)
      // 

      // default constructor
      SimpleServer() { }

#ifdef WITH_RMI

      // RMI connect
      static inline ::sidlx::rmi::SimpleServer _connect( /*in*/ const 
        std::string& url ) { 
        return _connect(url, true);
      }

      // RMI connect 2
      static ::sidlx::rmi::SimpleServer _connect( /*in*/ const std::string& url,
        /*in*/ const bool ar  );


#endif /*WITH_RMI*/

      // default destructor
      virtual ~SimpleServer () { }

      // copy constructor
      SimpleServer ( const SimpleServer& original );

      // assignment operator
      SimpleServer& operator= ( const SimpleServer& rhs );

      // conversion from ior to C++ class
      SimpleServer ( SimpleServer::ior_t* ior );

      // Alternate constructor: does not call addRef()
      // (sets d_weak_reference=isWeak)
      // For internal use by Impls (fixes bug#275)
      SimpleServer ( SimpleServer::ior_t* ior, bool isWeak );

      inline ior_t* _get_ior() const throw() {
        return reinterpret_cast< ior_t*>(d_self);
      }

      inline void _set_ior( ior_t* ptr ) throw () { 
        d_self = reinterpret_cast< void*>(ptr);

        if( ptr != NULL ) {
          sidl_rmi_ServerInfo_IORCache = &((*ptr).d_sidl_rmi_serverinfo);
        } else {
          sidl_rmi_ServerInfo_IORCache = NULL;
        }
      }

      virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                     const ::std::type_info &argtype );

      bool _is_nil() const throw () { return (d_self==0); }

      bool _not_nil() const throw () { return (d_self!=0); }

      bool operator !() const throw () { return (d_self==0); }

      static inline const char * type_name() throw () { return 
        "sidlx.rmi.SimpleServer";}

      static struct sidlx_rmi_SimpleServer__object* _cast(const void* src);

      // execute member function by name
      void _exec(const std::string& methodName,
                 ::sidl::rmi::Call& inArgs,
                 ::sidl::rmi::Return& outArgs);

      /**
       * Get the URL of the Implementation of this object (for RMI)
       */
      ::std::string
      _getURL() // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable method hooks invocation.
       */
      void
      _set_hooks (
        /* in */bool enable
      )
      // throws:
      //    ::sidl::RuntimeException
      ;

      // return true iff object is remote
      bool _isRemote() const { 
        ior_t* self = const_cast<ior_t*>(_get_ior() );
        struct sidl_BaseInterface__object *throwaway_exception;
        return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == TRUE;
      }

      // return true iff object is local
      bool _isLocal() const {
        return !_isRemote();
      }

    protected:
      // Pointer to external (DLL loadable) symbols (shared among instances)
      static const ext_t * s_ext;

      // Global cache for _get_sepv()
      static sepv_t *_sepv;

    public:
      static const ext_t * _get_ext() throw ( ::sidl::NullIORException );

    }; // end class SimpleServer
  } // end namespace rmi
} // end namespace sidlx

extern "C" {


#pragma weak sidlx_rmi_SimpleServer__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct sidlx_rmi_SimpleServer__object*
  sidlx_rmi_SimpleServer__connectI(const char * url, sidl_bool ar, struct 
    sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::sidlx::rmi::SimpleServer > {
    typedef array< ::sidlx::rmi::SimpleServer > cxx_array_t;
    typedef ::sidlx::rmi::SimpleServer cxx_item_t;
    typedef struct sidlx_rmi_SimpleServer__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct sidlx_rmi_SimpleServer__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::sidlx::rmi::SimpleServer > > iterator;
    typedef const_array_iter< array_traits< ::sidlx::rmi::SimpleServer > > 
      const_iterator;
  };

  // array specialization
  template<>
  class array< ::sidlx::rmi::SimpleServer >: public interface_array< 
    array_traits< ::sidlx::rmi::SimpleServer > > {
  public:
    typedef interface_array< array_traits< ::sidlx::rmi::SimpleServer > > Base;
    typedef array_traits< ::sidlx::rmi::SimpleServer >::cxx_array_t          
      cxx_array_t;
    typedef array_traits< ::sidlx::rmi::SimpleServer >::cxx_item_t           
      cxx_item_t;
    typedef array_traits< ::sidlx::rmi::SimpleServer >::ior_array_t          
      ior_array_t;
    typedef array_traits< ::sidlx::rmi::SimpleServer >::ior_array_internal_t 
      ior_array_internal_t;
    typedef array_traits< ::sidlx::rmi::SimpleServer >::ior_item_t           
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct sidlx_rmi_SimpleServer__array* src = 0) : Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::sidlx::rmi::SimpleServer >&src) : Base(src) {}

    /**
     * assignment
     */
    array< ::sidlx::rmi::SimpleServer >&
    operator =( const array< ::sidlx::rmi::SimpleServer >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#ifndef included_sidlx_rmi_Socket_hxx
#include "sidlx_rmi_Socket.hxx"
#endif
#endif
