// 
// File:          sidlx_rmi_SimpleTicketBook.hxx
// Symbol:        sidlx.rmi.SimpleTicketBook-v0.1
// Symbol Type:   class
// Babel Version: 2.0.0 (Revision: 7437  trunk)
// Description:   Client-side glue code for sidlx.rmi.SimpleTicketBook
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_sidlx_rmi_SimpleTicketBook_hxx
#define included_sidlx_rmi_SimpleTicketBook_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace sidlx { 
  namespace rmi { 

    class SimpleTicketBook;
  } // end namespace rmi
} // end namespace sidlx

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::sidlx::rmi::SimpleTicketBook >;
}
// 
// Forward declarations for method dependencies.
// 
namespace sidl { 

  class RuntimeException;
} // end namespace sidl

namespace sidl { 
  namespace rmi { 

    class Response;
  } // end namespace rmi
} // end namespace sidl

namespace sidl { 
  namespace rmi { 

    class Ticket;
  } // end namespace rmi
} // end namespace sidl

namespace sidl { 
  namespace rmi { 

    class TicketBook;
  } // end namespace rmi
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#include <stdint.h>
#ifndef included_sidlx_rmi_SimpleTicketBook_IOR_h
#include "sidlx_rmi_SimpleTicketBook_IOR.h"
#endif
#ifndef included_sidl_BaseClass_hxx
#include "sidl_BaseClass.hxx"
#endif
#ifndef included_sidl_rmi_TicketBook_hxx
#include "sidl_rmi_TicketBook.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace sidlx { 
  namespace rmi { 

    /**
     * Symbol "sidlx.rmi.SimpleTicketBook" (version 0.1)
     */
    class SimpleTicketBook: public virtual ::sidl::BaseClass, public virtual 
      ::sidl::rmi::TicketBook {

      //////////////////////////////////////////////////
      // 
      // Special methods for throwing exceptions
      // 

    private:
      static 
      void
      throwException0(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
      ;
    public:
      typedef struct sidlx_rmi_SimpleTicketBook__object ior_t;
      typedef struct sidlx_rmi_SimpleTicketBook__external ext_t;
      typedef struct sidlx_rmi_SimpleTicketBook__sepv sepv_t;


      //////////////////////////////////////////////////
      // 
      // User Defined Methods
      // 

    public:

      /**
       *  insert a ticket with a user-specified ID 
       */
      void
      insertWithID (
        /* in */const ::sidl::rmi::Ticket& t,
        /* in */int32_t id
      )
      ;


      /**
       *  insert a ticket and issue a unique ID 
       */
      int32_t
      insert (
        /* in */const ::sidl::rmi::Ticket& t
      )
      ;


      /**
       *  remove a ready ticket from the TicketBook
       * returns 0 (and null) on an empty TicketBook
       */
      int32_t
      removeReady (
        /* out */::sidl::rmi::Ticket& t
      )
      ;


      /**
       * immediate, returns the number of Tickets in the book.
       */
      bool
      isEmpty() ;

      /**
       *  blocks until the Response is received 
       */
      void
      block() ;

      /**
       *  
       * returns immediately: true iff the Response is already
       * received 
       */
      bool
      test() ;

      /**
       *  creates an empty container specialized for Tickets 
       */
      ::sidl::rmi::TicketBook
      createEmptyTicketBook() ;

      /**
       *  returns immediately: returns Response or null 
       * (NOTE: needed for implementors of communication
       * libraries, not expected for general use).
       */
      ::sidl::rmi::Response
      getResponse() ;

      //////////////////////////////////////////////////
      // 
      // End User Defined Methods
      // (everything else in this file is specific to
      //  Babel's C++ bindings)
      // 

      // default constructor
      SimpleTicketBook() { }
      // static constructor
      static ::sidlx::rmi::SimpleTicketBook _create();


#ifdef WITH_RMI

      // RMI constructor
      static ::sidlx::rmi::SimpleTicketBook _create( /*in*/ const std::string& 
        url );

      // RMI connect
      static inline ::sidlx::rmi::SimpleTicketBook _connect( /*in*/ const 
        std::string& url ) { 
        return _connect(url, true);
      }

      // RMI connect 2
      static ::sidlx::rmi::SimpleTicketBook _connect( /*in*/ const std::string& 
        url, /*in*/ const bool ar  );


#endif /*WITH_RMI*/

      // default destructor
      virtual ~SimpleTicketBook () { }

      // copy constructor
      SimpleTicketBook ( const SimpleTicketBook& original );

      // assignment operator
      SimpleTicketBook& operator= ( const SimpleTicketBook& rhs );


      protected:
      // Internal data wrapping method
      static ior_t*  _wrapObj(void* private_data);


      public:
      // conversion from ior to C++ class
      SimpleTicketBook ( SimpleTicketBook::ior_t* ior );

      // Alternate constructor: does not call addRef()
      // (sets d_weak_reference=isWeak)
      // For internal use by Impls (fixes bug#275)
      SimpleTicketBook ( SimpleTicketBook::ior_t* ior, bool isWeak );

      inline ior_t* _get_ior() const throw() {
        return reinterpret_cast< ior_t*>(d_self);
      }

      inline void _set_ior( ior_t* ptr ) throw () { 
        d_self = reinterpret_cast< void*>(ptr);

        if( ptr != NULL ) {
          sidl_rmi_Ticket_IORCache = &((*ptr).d_sidl_rmi_ticket);
          sidl_rmi_TicketBook_IORCache = &((*ptr).d_sidl_rmi_ticketbook);
        } else {
          sidl_rmi_Ticket_IORCache = NULL;
          sidl_rmi_TicketBook_IORCache = NULL;
        }
      }

      virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                     const ::std::type_info &argtype );

      bool _is_nil() const throw () { return (d_self==0); }

      bool _not_nil() const throw () { return (d_self!=0); }

      bool operator !() const throw () { return (d_self==0); }

      static inline const char * type_name() throw () { return 
        "sidlx.rmi.SimpleTicketBook";}

      static struct sidlx_rmi_SimpleTicketBook__object* _cast(const void* src);

      // execute member function by name
      void _exec(const std::string& methodName,
                 ::sidl::rmi::Call& inArgs,
                 ::sidl::rmi::Return& outArgs);

      /**
       * Get the URL of the Implementation of this object (for RMI)
       */
      ::std::string
      _getURL() // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable method hooks invocation.
       */
      void
      _set_hooks (
        /* in */bool enable
      )
      // throws:
      //    ::sidl::RuntimeException
      ;

      // return true iff object is remote
      bool _isRemote() const { 
        ior_t* self = const_cast<ior_t*>(_get_ior() );
        struct sidl_BaseInterface__object *throwaway_exception;
        return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == TRUE;
      }

      // return true iff object is local
      bool _isLocal() const {
        return !_isRemote();
      }

    protected:
      // Pointer to external (DLL loadable) symbols (shared among instances)
      static const ext_t * s_ext;

      // Global cache for _get_sepv()
      static sepv_t *_sepv;

    public:
      static const ext_t * _get_ext() throw ( ::sidl::NullIORException );

    }; // end class SimpleTicketBook
  } // end namespace rmi
} // end namespace sidlx

extern "C" {


#pragma weak sidlx_rmi_SimpleTicketBook__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct sidlx_rmi_SimpleTicketBook__object*
  sidlx_rmi_SimpleTicketBook__connectI(const char * url, sidl_bool ar, struct 
    sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::sidlx::rmi::SimpleTicketBook > {
    typedef array< ::sidlx::rmi::SimpleTicketBook > cxx_array_t;
    typedef ::sidlx::rmi::SimpleTicketBook cxx_item_t;
    typedef struct sidlx_rmi_SimpleTicketBook__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct sidlx_rmi_SimpleTicketBook__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::sidlx::rmi::SimpleTicketBook > > 
      iterator;
    typedef const_array_iter< array_traits< ::sidlx::rmi::SimpleTicketBook > > 
      const_iterator;
  };

  // array specialization
  template<>
  class array< ::sidlx::rmi::SimpleTicketBook >: public interface_array< 
    array_traits< ::sidlx::rmi::SimpleTicketBook > > {
  public:
    typedef interface_array< array_traits< ::sidlx::rmi::SimpleTicketBook > > 
      Base;
    typedef array_traits< ::sidlx::rmi::SimpleTicketBook >::cxx_array_t         
      cxx_array_t;
    typedef array_traits< ::sidlx::rmi::SimpleTicketBook >::cxx_item_t          
      cxx_item_t;
    typedef array_traits< ::sidlx::rmi::SimpleTicketBook >::ior_array_t         
      ior_array_t;
    typedef array_traits< ::sidlx::rmi::SimpleTicketBook 
      >::ior_array_internal_t ior_array_internal_t;
    typedef array_traits< ::sidlx::rmi::SimpleTicketBook >::ior_item_t          
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct sidlx_rmi_SimpleTicketBook__array* src = 0) : Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::sidlx::rmi::SimpleTicketBook >&src) : Base(src) {}

    /**
     * assignment
     */
    array< ::sidlx::rmi::SimpleTicketBook >&
    operator =( const array< ::sidlx::rmi::SimpleTicketBook >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#ifndef included_sidl_rmi_Response_hxx
#include "sidl_rmi_Response.hxx"
#endif
#ifndef included_sidl_rmi_Ticket_hxx
#include "sidl_rmi_Ticket.hxx"
#endif
#endif
