// 
// File:          sidlx_rmi_Socket.hxx
// Symbol:        sidlx.rmi.Socket-v0.1
// Symbol Type:   interface
// Babel Version: 2.0.0 (Revision: 7437  trunk)
// Description:   Client-side glue code for sidlx.rmi.Socket
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_sidlx_rmi_Socket_hxx
#define included_sidlx_rmi_Socket_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace sidlx { 
  namespace rmi { 

    class Socket;
  } // end namespace rmi
} // end namespace sidlx

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::sidlx::rmi::Socket >;
}
// 
// Forward declarations for method dependencies.
// 
namespace sidl { 

  class RuntimeException;
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#include <stdint.h>
#ifndef included_sidlx_rmi_Socket_IOR_h
#include "sidlx_rmi_Socket_IOR.h"
#endif
#ifndef included_sidl_BaseInterface_hxx
#include "sidl_BaseInterface.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace sidlx { 
  namespace rmi { 

    /**
     * Symbol "sidlx.rmi.Socket" (version 0.1)
     * 
     * Basic socket functionality, writeline, readline, etc.  Should be threadsafe
     * (As long as you don't have multiple threads on the same socket) 	
     */
    class Socket: public virtual ::sidl::BaseInterface {

      //////////////////////////////////////////////////
      // 
      // Special methods for throwing exceptions
      // 

    private:
      static 
      void
      throwException0(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
      ;
    public:
      typedef struct sidlx_rmi_Socket__object ior_t;
      typedef struct sidlx_rmi_Socket__external ext_t;
      typedef struct sidlx_rmi_Socket__sepv sepv_t;


      //////////////////////////////////////////////////
      // 
      // Locally Cached IOR pointer
      // 

    protected:
      mutable ior_t* sidlx_rmi_Socket_IORCache;

      //////////////////////////////////////////////////
      // 
      // User Defined Methods
      // 

    public:
      /**
       * user defined non-static method
       */
      int32_t
      close() ;
      /**
       * user defined non-static method
       */
      int32_t
      readn (
        /* in */int32_t nbytes,
        /* inout array<char> */::sidl::array<char>& data
      )
      ;

      /**
       * user defined non-static method
       */
      int32_t
      readline (
        /* in */int32_t nbytes,
        /* inout array<char> */::sidl::array<char>& data
      )
      ;

      /**
       * user defined non-static method
       */
      int32_t
      readstring (
        /* in */int32_t nbytes,
        /* inout array<char> */::sidl::array<char>& data
      )
      ;

      /**
       * user defined non-static method
       */
      int32_t
      readstring_alloc (
        /* inout array<char> */::sidl::array<char>& data
      )
      ;

      /**
       * user defined non-static method
       */
      int32_t
      readint (
        /* inout */int32_t& data
      )
      ;

      /**
       * user defined non-static method
       */
      int32_t
      writen (
        /* in */int32_t nbytes,
        /* in array<char> */const ::sidl::array<char>& data
      )
      ;

      /**
       * user defined non-static method
       */
      int32_t
      writestring (
        /* in */int32_t nbytes,
        /* in array<char> */const ::sidl::array<char>& data
      )
      ;

      /**
       * user defined non-static method
       */
      int32_t
      writeint (
        /* in */int32_t data
      )
      ;

      /**
       * user defined non-static method
       */
      void
      setFileDescriptor (
        /* in */int32_t fd
      )
      ;

      /**
       * user defined non-static method
       */
      int32_t
      getFileDescriptor() ;
      /**
       * user defined non-static method
       */
      bool
      test (
        /* in */int32_t secs,
        /* in */int32_t usecs
      )
      ;


      //////////////////////////////////////////////////
      // 
      // End User Defined Methods
      // (everything else in this file is specific to
      //  Babel's C++ bindings)
      // 

      // default constructor
      Socket()  : 
      sidlx_rmi_Socket_IORCache((ior_t*) NULL){ }

#ifdef WITH_RMI

      // RMI connect
      static inline ::sidlx::rmi::Socket _connect( /*in*/ const std::string& 
        url ) { 
        return _connect(url, true);
      }

      // RMI connect 2
      static ::sidlx::rmi::Socket _connect( /*in*/ const std::string& url, 
        /*in*/ const bool ar  );


#endif /*WITH_RMI*/

      // default destructor
      virtual ~Socket () { }

      // copy constructor
      Socket ( const Socket& original );

      // assignment operator
      Socket& operator= ( const Socket& rhs );

      // conversion from ior to C++ class
      Socket ( Socket::ior_t* ior );

      // Alternate constructor: does not call addRef()
      // (sets d_weak_reference=isWeak)
      // For internal use by Impls (fixes bug#275)
      Socket ( Socket::ior_t* ior, bool isWeak );

      inline ior_t* _get_ior() const throw() {
        if(!sidlx_rmi_Socket_IORCache) { 
          sidlx_rmi_Socket_IORCache = ::sidlx::rmi::Socket::_cast((
            void*)d_self);
          if (sidlx_rmi_Socket_IORCache) {
            struct sidl_BaseInterface__object *throwaway_exception;
            (sidlx_rmi_Socket_IORCache->d_epv->f_deleteRef)(
              sidlx_rmi_Socket_IORCache->d_object, &throwaway_exception);  
          }  
        }
        return sidlx_rmi_Socket_IORCache;
      }

      inline void _set_ior( ior_t* ptr ) throw () { 
        d_self = reinterpret_cast< void*>(ptr);
        sidlx_rmi_Socket_IORCache = (ior_t*) ptr;

      }

      virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                     const ::std::type_info &argtype );

      bool _is_nil() const throw () { return (d_self==0); }

      bool _not_nil() const throw () { return (d_self!=0); }

      bool operator !() const throw () { return (d_self==0); }

      static inline const char * type_name() throw () { return 
        "sidlx.rmi.Socket";}

      static struct sidlx_rmi_Socket__object* _cast(const void* src);

      // execute member function by name
      void _exec(const std::string& methodName,
                 ::sidl::rmi::Call& inArgs,
                 ::sidl::rmi::Return& outArgs);

      /**
       * Get the URL of the Implementation of this object (for RMI)
       */
      ::std::string
      _getURL() // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable method hooks invocation.
       */
      void
      _set_hooks (
        /* in */bool enable
      )
      // throws:
      //    ::sidl::RuntimeException
      ;

      // return true iff object is remote
      bool _isRemote() const { 
        ior_t* self = const_cast<ior_t*>(_get_ior() );
        struct sidl_BaseInterface__object *throwaway_exception;
        return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == TRUE;
      }

      // return true iff object is local
      bool _isLocal() const {
        return !_isRemote();
      }

    protected:
      // Pointer to external (DLL loadable) symbols (shared among instances)
      static const ext_t * s_ext;

      // Global cache for _get_sepv()
      static sepv_t *_sepv;

    public:
      static const ext_t * _get_ext() throw ( ::sidl::NullIORException );

    }; // end class Socket
  } // end namespace rmi
} // end namespace sidlx

extern "C" {


#pragma weak sidlx_rmi_Socket__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct sidlx_rmi_Socket__object*
  sidlx_rmi_Socket__connectI(const char * url, sidl_bool ar, struct 
    sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::sidlx::rmi::Socket > {
    typedef array< ::sidlx::rmi::Socket > cxx_array_t;
    typedef ::sidlx::rmi::Socket cxx_item_t;
    typedef struct sidlx_rmi_Socket__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct sidlx_rmi_Socket__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::sidlx::rmi::Socket > > iterator;
    typedef const_array_iter< array_traits< ::sidlx::rmi::Socket > > 
      const_iterator;
  };

  // array specialization
  template<>
  class array< ::sidlx::rmi::Socket >: public interface_array< array_traits< 
    ::sidlx::rmi::Socket > > {
  public:
    typedef interface_array< array_traits< ::sidlx::rmi::Socket > > Base;
    typedef array_traits< ::sidlx::rmi::Socket >::cxx_array_t          
      cxx_array_t;
    typedef array_traits< ::sidlx::rmi::Socket >::cxx_item_t           
      cxx_item_t;
    typedef array_traits< ::sidlx::rmi::Socket >::ior_array_t          
      ior_array_t;
    typedef array_traits< ::sidlx::rmi::Socket >::ior_array_internal_t 
      ior_array_internal_t;
    typedef array_traits< ::sidlx::rmi::Socket >::ior_item_t           
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct sidlx_rmi_Socket__array* src = 0) : Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::sidlx::rmi::Socket >&src) : Base(src) {}

    /**
     * assignment
     */
    array< ::sidlx::rmi::Socket >&
    operator =( const array< ::sidlx::rmi::Socket >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#endif
