/*
 * File:          sidl_BaseInterface_jniStub.c
 * Symbol:        sidl.BaseInterface-v0.9.17
 * Symbol Type:   interface
 * Babel Version: 2.0.0 (Revision: 7437  trunk)
 * Release:       $Name:  $
 * Revision:      @(#) $Id: $
 * Description:   Client-side JNI glue code for sidl.BaseInterface
 * 
 * Copyright (c) 2000-2002, Lawrence Livermore National Security, LLC.
 * Produced at the Lawrence Livermore National Laboratory.
 * Written by the Components Team <components@llnl.gov>
 * All rights reserved.
 * 
 * This file is part of Babel. For more information, see
 * http://www.llnl.gov/CASC/components/. Please read the COPYRIGHT file
 * for Our Notice and the LICENSE file for the GNU Lesser General Public
 * License.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License (as published by
 * the Free Software Foundation) version 2.1 dated February 1999.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms and
 * conditions of the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 */

#include "sidl_Java.h"
#include "sidl_Loader.h"
#include "sidl_String.h"
#include "sidl_BaseInterface_IOR.h"
#include "babel_config.h"
/*
 * Includes for all method dependencies.
 */

#ifndef included_sidl_BaseInterface_jniStub_h
#include "sidl_BaseInterface_jniStub.h"
#endif
#ifndef included_sidl_ClassInfo_jniStub_h
#include "sidl_ClassInfo_jniStub.h"
#endif
#ifndef included_sidl_RuntimeException_jniStub_h
#include "sidl_RuntimeException_jniStub.h"
#endif



/*
 * Convert between jlong and void* pointers.
 */

#if (SIZEOF_VOID_P == 8)
#define JLONG_TO_POINTER(x) ((void*)(x))
#define POINTER_TO_JLONG(x) ((jlong)(x))
#else
#define JLONG_TO_POINTER(x) ((void*)(int32_t)(x))
#define POINTER_TO_JLONG(x) ((jlong)(int32_t)(x))
#endif

#ifndef NULL
#define NULL 0
#endif


#define LANG_SPECIFIC_INIT()

#ifdef WITH_RMI

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#ifndef included_sidl_BaseClass_h
#include "sidl_BaseClass.h"
#endif
#ifndef included_sidl_ClassInfo_h
#include "sidl_ClassInfo.h"
#endif
#ifndef included_sidl_rmi_ProtocolFactory_h
#include "sidl_rmi_ProtocolFactory.h"
#endif
#ifndef included_sidl_rmi_InstanceRegistry_h
#include "sidl_rmi_InstanceRegistry.h"
#endif
#ifndef included_sidl_rmi_InstanceHandle_h
#include "sidl_rmi_InstanceHandle.h"
#endif
#ifndef included_sidl_rmi_Invocation_h
#include "sidl_rmi_Invocation.h"
#endif
#ifndef included_sidl_rmi_Response_h
#include "sidl_rmi_Response.h"
#endif
#ifndef included_sidl_rmi_ServerRegistry_h
#include "sidl_rmi_ServerRegistry.h"
#endif
#ifndef included_sidl_rmi_ConnectRegistry_h
#include "sidl_rmi_ConnectRegistry.h"
#endif
#ifndef included_sidl_io_Serializable_h
#include "sidl_io_Serializable.h"
#endif
#ifndef included_sidl_MemAllocException_h
#include "sidl_MemAllocException.h"
#endif
#ifndef included_sidl_NotImplementedException_h
#include "sidl_NotImplementedException.h"
#endif
#include "sidl_Exception.h"

#ifndef NULL
#define NULL 0
#endif

#include "sidl_thread.h"
#ifdef HAVE_PTHREAD
static struct sidl_recursive_mutex_t sidl__BaseInterface__mutex= SIDL_RECURSIVE_MUTEX_INITIALIZER;
#define LOCK_STATIC_GLOBALS sidl_recursive_mutex_lock( &sidl__BaseInterface__mutex )
#define UNLOCK_STATIC_GLOBALS sidl_recursive_mutex_unlock( &sidl__BaseInterface__mutex )
/* #define HAVE_LOCKED_STATIC_GLOBALS (sidl_recursive_mutex_trylock( &sidl__BaseInterface__mutex )==EDEADLOCK) */
#else
#define LOCK_STATIC_GLOBALS
#define UNLOCK_STATIC_GLOBALS
/* #define HAVE_LOCKED_STATIC_GLOBALS (1) */
#endif

/* Static variables to hold version of IOR */
static const int32_t s_IOR_MAJOR_VERSION = 2;
static const int32_t s_IOR_MINOR_VERSION = 0;

/* Static variables for managing EPV initialization. */
static int s_remote_initialized = 0;

static struct sidl__BaseInterface__epv s_rem_epv__sidl__baseinterface;

static struct sidl_BaseInterface__epv s_rem_epv__sidl_baseinterface;


/* REMOTE CAST: dynamic type casting for remote objects. */
static void* remote_sidl__BaseInterface__cast(
  struct sidl__BaseInterface__object* self,
  const char* name, sidl_BaseInterface* _ex)
{
  int cmp;
  void* cast = NULL;
  *_ex = NULL; /* default to no exception */
  cmp = strcmp(name, "sidl._BaseInterface");
  if (!cmp) {
    (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
    cast = ((struct sidl__BaseInterface__object*)self);
    return cast;
  }
  else if (cmp < 0) {
    cmp = strcmp(name, "sidl.BaseInterface");
    if (!cmp) {
      (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
      cast = &((*self).d_sidl_baseinterface);
      return cast;
    }
  }
  if ((*self->d_epv->f_isType)(self,name, _ex)) {
    void* (*func)(struct sidl_rmi_InstanceHandle__object*, struct 
      sidl_BaseInterface__object**) = 
      (void* (*)(struct sidl_rmi_InstanceHandle__object*, struct 
        sidl_BaseInterface__object**)) 
      sidl_rmi_ConnectRegistry_getConnect(name, _ex);SIDL_CHECK(*_ex);
    cast =  (*func)(((struct sidl__BaseInterface__remote*)self->d_data)->d_ih, 
      _ex);
  }

  return cast;
  EXIT:
  return NULL;
}

/* REMOTE DELETE: call the remote destructor for the object. */
static void remote_sidl__BaseInterface__delete(
  struct sidl__BaseInterface__object* self,
  struct sidl_BaseInterface__object* *_ex)
{
  *_ex = NULL;
  free((void*) self);
}

/* REMOTE GETURL: call the getURL function for the object. */
static char* remote_sidl__BaseInterface__getURL(
  struct sidl__BaseInterface__object* self, struct sidl_BaseInterface__object* 
    *_ex)
{
  struct sidl_rmi_InstanceHandle__object *conn = ((struct 
    sidl__BaseInterface__remote*)self->d_data)->d_ih;
  *_ex = NULL;
  if(conn != NULL) {
    return sidl_rmi_InstanceHandle_getObjectURL(conn, _ex);
  }
  return NULL;
}

/* REMOTE ADDREF: For internal babel use only! Remote addRef. */
static void remote_sidl__BaseInterface__raddRef(
  struct sidl__BaseInterface__object* self,struct sidl_BaseInterface__object* 
    *_ex)
{
  struct sidl_BaseException__object* netex = NULL;
  /* initialize a new invocation */
  struct sidl_BaseInterface__object* _throwaway = NULL;
  struct sidl_rmi_InstanceHandle__object *_conn = ((struct 
    sidl__BaseInterface__remote*)self->d_data)->d_ih;
  sidl_rmi_Response _rsvp = NULL;
  sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
    "addRef", _ex ); SIDL_CHECK(*_ex);
  /* send actual RMI request */
  _rsvp = sidl_rmi_Invocation_invokeMethod(_inv,_ex);SIDL_CHECK(*_ex);
  /* Check for exceptions */
  netex = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);
  if(netex != NULL) {
    *_ex = (struct sidl_BaseInterface__object*)netex;
    return;
  }

  /* cleanup and return */
  EXIT:
  if(_inv) { sidl_rmi_Invocation_deleteRef(_inv,&_throwaway); }
  if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp,&_throwaway); }
  return;
}

/* REMOTE ISREMOTE: returns true if this object is Remote (it is). */
static sidl_bool
remote_sidl__BaseInterface__isRemote(
    struct sidl__BaseInterface__object* self, 
    struct sidl_BaseInterface__object* *_ex) {
  *_ex = NULL;
  return TRUE;
}

/* REMOTE METHOD STUB:_set_hooks */
static void
remote_sidl__BaseInterface__set_hooks(
  /* in */ struct sidl__BaseInterface__object*self ,
  /* in */ sidl_bool enable,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      sidl__BaseInterface__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "_set_hooks", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packBool( _inv, "enable", enable, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from sidl._BaseInterface._set_hooks.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* Contract enforcement has not been implemented for remote use. */
/* REMOTE METHOD STUB:_set_contracts */
static void
remote_sidl__BaseInterface__set_contracts(
  /* in */ struct sidl__BaseInterface__object*self ,
  /* in */ sidl_bool enable,
  /* in */ const char* enfFilename,
  /* in */ sidl_bool resetCounters,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      sidl__BaseInterface__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "_set_contracts", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packBool( _inv, "enable", enable, _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Invocation_packString( _inv, "enfFilename", enfFilename, 
      _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Invocation_packBool( _inv, "resetCounters", resetCounters, 
      _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from sidl._BaseInterface._set_contracts.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* Contract enforcement has not been implemented for remote use. */
/* REMOTE METHOD STUB:_dump_stats */
static void
remote_sidl__BaseInterface__dump_stats(
  /* in */ struct sidl__BaseInterface__object*self ,
  /* in */ const char* filename,
  /* in */ const char* prefix,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      sidl__BaseInterface__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "_dump_stats", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "filename", filename, _ex);SIDL_CHECK(
      *_ex);
    sidl_rmi_Invocation_packString( _inv, "prefix", prefix, _ex);SIDL_CHECK(
      *_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from sidl._BaseInterface._dump_stats.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE EXEC: call the exec function for the object. */
static void remote_sidl__BaseInterface__exec(
  struct sidl__BaseInterface__object* self,const char* methodName,
  sidl_rmi_Call inArgs,
  sidl_rmi_Return outArgs,
  struct sidl_BaseInterface__object* *_ex)
{
  *_ex = NULL;
}

/* REMOTE METHOD STUB:addRef */
static void
remote_sidl__BaseInterface_addRef(
  /* in */ struct sidl__BaseInterface__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    struct sidl__BaseInterface__remote* r_obj = (struct 
      sidl__BaseInterface__remote*)self->d_data;
    LOCK_STATIC_GLOBALS;
    r_obj->d_refcount++;
#ifdef SIDL_DEBUG_REFCOUNT
    fprintf(stderr, "babel: addRef %p new count %d (type %s)\n",
      r_obj, r_obj->d_refcount, 
      "sidl._BaseInterface Remote Stub");
#endif /* SIDL_DEBUG_REFCOUNT */ 
    UNLOCK_STATIC_GLOBALS;
  }
}

/* REMOTE METHOD STUB:deleteRef */
static void
remote_sidl__BaseInterface_deleteRef(
  /* in */ struct sidl__BaseInterface__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    struct sidl__BaseInterface__remote* r_obj = (struct 
      sidl__BaseInterface__remote*)self->d_data;
    LOCK_STATIC_GLOBALS;
    r_obj->d_refcount--;
#ifdef SIDL_DEBUG_REFCOUNT
    fprintf(stderr, "babel: deleteRef %p new count %d (type %s)\n",r_obj, r_obj->d_refcount, "sidl._BaseInterface Remote Stub");
#endif /* SIDL_DEBUG_REFCOUNT */ 
    if(r_obj->d_refcount == 0) {
      sidl_rmi_InstanceHandle_deleteRef(r_obj->d_ih, _ex);
      free(r_obj);
      free(self);
    }
    UNLOCK_STATIC_GLOBALS;
  }
}

/* REMOTE METHOD STUB:isSame */
static sidl_bool
remote_sidl__BaseInterface_isSame(
  /* in */ struct sidl__BaseInterface__object*self ,
  /* in */ struct sidl_BaseInterface__object* iobj,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    sidl_bool _retval = FALSE;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      sidl__BaseInterface__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "isSame", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(iobj){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)iobj, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "iobj", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "iobj", NULL, _ex);SIDL_CHECK(*_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from sidl._BaseInterface.isSame.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackBool( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:isType */
static sidl_bool
remote_sidl__BaseInterface_isType(
  /* in */ struct sidl__BaseInterface__object*self ,
  /* in */ const char* name,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    sidl_bool _retval = FALSE;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      sidl__BaseInterface__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "isType", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "name", name, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from sidl._BaseInterface.isType.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackBool( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:getClassInfo */
static struct sidl_ClassInfo__object*
remote_sidl__BaseInterface_getClassInfo(
  /* in */ struct sidl__BaseInterface__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct sidl_ClassInfo__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      sidl__BaseInterface__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "getClassInfo", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from sidl._BaseInterface.getClassInfo.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str, 
      _ex);SIDL_CHECK(*_ex);
    _retval = sidl_ClassInfo__connectI(_retval_str, FALSE, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE EPV: create remote entry point vectors (EPVs). */
static void sidl__BaseInterface__init_remote_epv(void)
{
  /* assert( HAVE_LOCKED_STATIC_GLOBALS ); */
  struct sidl__BaseInterface__epv* epv = &s_rem_epv__sidl__baseinterface;
  struct sidl_BaseInterface__epv*  e0  = &s_rem_epv__sidl_baseinterface;

  epv->f__cast               = remote_sidl__BaseInterface__cast;
  epv->f__delete             = remote_sidl__BaseInterface__delete;
  epv->f__exec               = remote_sidl__BaseInterface__exec;
  epv->f__getURL             = remote_sidl__BaseInterface__getURL;
  epv->f__raddRef            = remote_sidl__BaseInterface__raddRef;
  epv->f__isRemote           = remote_sidl__BaseInterface__isRemote;
  epv->f__set_hooks          = remote_sidl__BaseInterface__set_hooks;
  epv->f__set_contracts      = remote_sidl__BaseInterface__set_contracts;
  epv->f__dump_stats         = remote_sidl__BaseInterface__dump_stats;
  epv->f__ctor               = NULL;
  epv->f__ctor2              = NULL;
  epv->f__dtor               = NULL;
  epv->f_addRef              = remote_sidl__BaseInterface_addRef;
  epv->f_deleteRef           = remote_sidl__BaseInterface_deleteRef;
  epv->f_isSame              = remote_sidl__BaseInterface_isSame;
  epv->f_isType              = remote_sidl__BaseInterface_isType;
  epv->f_getClassInfo        = remote_sidl__BaseInterface_getClassInfo;

  e0->f__cast          = (void* (*)(void*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__cast;
  e0->f__delete        = (void (*)(void*, struct sidl_BaseInterface__object**)) 
    epv->f__delete;
  e0->f__getURL        = (char* (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__getURL;
  e0->f__raddRef       = (void (*)(void*, struct sidl_BaseInterface__object**)) 
    epv->f__raddRef;
  e0->f__isRemote      = (sidl_bool (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__isRemote;
  e0->f__set_hooks     = (void (*)(void*, sidl_bool, struct 
    sidl_BaseInterface__object**)) epv->f__set_hooks;
  e0->f__set_contracts = (void (*)(void*, sidl_bool, const char*, sidl_bool, 
    struct sidl_BaseInterface__object**)) epv->f__set_contracts;
  e0->f__dump_stats    = (void (*)(void*, const char*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__dump_stats;
  e0->f__exec          = (void (*)(void*,const char*,struct 
    sidl_rmi_Call__object*,struct sidl_rmi_Return__object*,struct 
    sidl_BaseInterface__object **)) epv->f__exec;
  e0->f_addRef         = (void (*)(void*,struct sidl_BaseInterface__object **)) 
    epv->f_addRef;
  e0->f_deleteRef      = (void (*)(void*,struct sidl_BaseInterface__object **)) 
    epv->f_deleteRef;
  e0->f_isSame         = (sidl_bool (*)(void*,struct 
    sidl_BaseInterface__object*,struct sidl_BaseInterface__object **)) 
    epv->f_isSame;
  e0->f_isType         = (sidl_bool (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_isType;
  e0->f_getClassInfo   = (struct sidl_ClassInfo__object* (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_getClassInfo;

  s_remote_initialized = 1;
}

/* Create an instance that connects to an existing remote object. */
static struct sidl_BaseInterface__object*
sidl_BaseInterface__remoteConnect(const char *url, sidl_bool ar, struct 
  sidl_BaseInterface__object* *_ex)
{
  struct sidl__BaseInterface__object* self = NULL;

  struct sidl__BaseInterface__object* s0;

  struct sidl__BaseInterface__remote* r_obj = NULL;
  sidl_rmi_InstanceHandle instance = NULL;
  struct sidl_BaseInterface__object* ret_self = NULL;
  char* objectID = NULL;
  objectID = sidl_rmi_ServerRegistry_isLocalObject(url, _ex);
  if(objectID) {
    sidl_BaseInterface bi = (sidl_BaseInterface) 
      sidl_rmi_InstanceRegistry_getInstanceByString(objectID, _ex);
    return (struct sidl_BaseInterface__object*)(*bi->d_epv->f__cast)(
      bi->d_object, "sidl.BaseInterface", _ex);
  }
  instance = sidl_rmi_ProtocolFactory_connectInstance(url, "sidl.BaseInterface",
    ar, _ex );
  if ( instance == NULL) { return NULL; }
  self =
    (struct sidl__BaseInterface__object*) malloc(
      sizeof(struct sidl__BaseInterface__object));

  r_obj =
    (struct sidl__BaseInterface__remote*) malloc(
      sizeof(struct sidl__BaseInterface__remote));

  if(!self || !r_obj) {
    sidl_MemAllocException ex = sidl_MemAllocException_getSingletonException(
      _ex);
    SIDL_CHECK(*_ex);
    sidl_MemAllocException_setNote(ex, "Out of memory.", _ex); SIDL_CHECK(*_ex);
    sidl_MemAllocException_add(ex, __FILE__, __LINE__, 
      "sidl._BaseInterface.EPVgeneration", _ex);
    SIDL_CHECK(*_ex);
    *_ex = (struct sidl_BaseInterface__object*)ex;
    goto EXIT;
  }

  r_obj->d_refcount = 1;
  r_obj->d_ih = instance;
  s0 =                               self;

  LOCK_STATIC_GLOBALS;
  if (!s_remote_initialized) {
    sidl__BaseInterface__init_remote_epv();
  }
  UNLOCK_STATIC_GLOBALS;

  s0->d_sidl_baseinterface.d_epv    = &s_rem_epv__sidl_baseinterface;
  s0->d_sidl_baseinterface.d_object = (void*) self;

  s0->d_data = (void*) r_obj;
  s0->d_epv  = &s_rem_epv__sidl__baseinterface;

  self->d_data = (void*) r_obj;

  ret_self = (struct sidl_BaseInterface__object*) (*self->d_epv->f__cast)(self, 
    "sidl.BaseInterface", _ex);
  if(*_ex || !ret_self) { goto EXIT; }
  return ret_self;
  EXIT:
  if(self) { free(self); }
  if(r_obj) { free(r_obj); }
  return NULL;
}
/* Create an instance that uses an already existing  */
/* InstanceHandle to connect to an existing remote object. */
static struct sidl_BaseInterface__object*
sidl_BaseInterface__IHConnect(sidl_rmi_InstanceHandle instance, struct 
  sidl_BaseInterface__object* *_ex)
{
  struct sidl__BaseInterface__object* self = NULL;

  struct sidl__BaseInterface__object* s0;

  struct sidl__BaseInterface__remote* r_obj = NULL;
  struct sidl_BaseInterface__object* ret_self = NULL;
  self =
    (struct sidl__BaseInterface__object*) malloc(
      sizeof(struct sidl__BaseInterface__object));

  r_obj =
    (struct sidl__BaseInterface__remote*) malloc(
      sizeof(struct sidl__BaseInterface__remote));

  if(!self || !r_obj) {
    sidl_MemAllocException ex = sidl_MemAllocException_getSingletonException(
      _ex);
    SIDL_CHECK(*_ex);
    sidl_MemAllocException_setNote(ex, "Out of memory.", _ex); SIDL_CHECK(*_ex);
    sidl_MemAllocException_add(ex, __FILE__, __LINE__, 
      "sidl._BaseInterface.EPVgeneration", _ex);
    SIDL_CHECK(*_ex);
    *_ex = (struct sidl_BaseInterface__object*)ex;
    goto EXIT;
  }

  r_obj->d_refcount = 1;
  r_obj->d_ih = instance;
  s0 =                               self;

  LOCK_STATIC_GLOBALS;
  if (!s_remote_initialized) {
    sidl__BaseInterface__init_remote_epv();
  }
  UNLOCK_STATIC_GLOBALS;

  s0->d_sidl_baseinterface.d_epv    = &s_rem_epv__sidl_baseinterface;
  s0->d_sidl_baseinterface.d_object = (void*) self;

  s0->d_data = (void*) r_obj;
  s0->d_epv  = &s_rem_epv__sidl__baseinterface;

  self->d_data = (void*) r_obj;

  sidl_rmi_InstanceHandle_addRef(instance, _ex);

  ret_self = (struct sidl_BaseInterface__object*) (*self->d_epv->f__cast)(self, 
    "sidl.BaseInterface", _ex);
  if(*_ex || !ret_self) { goto EXIT; }
  return ret_self;
  EXIT:
  if(self) { free(self); }
  if(r_obj) { free(r_obj); }
  return NULL;
}
/*
 * RMI connector function for the class.
 */

struct sidl_BaseInterface__object*
sidl_BaseInterface__connectI(const char* url, sidl_bool ar, struct 
  sidl_BaseInterface__object **_ex)
{
  return sidl_BaseInterface__remoteConnect(url, ar, _ex);
}


#endif /*WITH_RMI*/
/*
 * Function to extract IOR reference from the Java object.
 */

static struct sidl_BaseInterface__object* _get_ior(
  JNIEnv* env,
  jobject obj)
{
  void* ptr = NULL;
  static jmethodID mid = (jmethodID) NULL;

  if (mid == (jmethodID) NULL) {
    jclass cls = (*env)->GetObjectClass(env, obj);
    mid = (*env)->GetMethodID(env, cls, "_get_ior", "()J");
    (*env)->DeleteLocalRef(env, cls);
  }

  ptr = JLONG_TO_POINTER((*env)->CallLongMethod(env, obj, mid));
  return (struct sidl_BaseInterface__object*) ptr;
}

/*
 * Connect to a remote object instance and return reference.
 */

static jlong jni__connect_remote_ior(
  JNIEnv* env,
  jclass  cls,
  jstring url)
{
  jlong _res = 0;

#ifdef WITH_RMI

  struct sidl_BaseInterface__object *_ex = NULL;
  char* _tmp_url = sidl_Java_J2I_string(env, url);
  _res = POINTER_TO_JLONG(sidl_BaseInterface__remoteConnect(_tmp_url, 1, &_ex));
  if(_ex) {
    sidl_Java_CheckException(
      env,
      _ex,
      "sidl.RuntimeException",
      NULL);

    return _res;
  }

#endif /*WITH_RMI*/

  (void) env;
  (void) cls;
  return _res;

}

/*
 * <p>
 * Add one to the intrinsic reference count in the underlying object.
 * Object in <code>sidl</code> have an intrinsic reference count.
 * Objects continue to exist as long as the reference count is
 * positive. Clients should call this method whenever they
 * create another ongoing reference to an object or interface.
 * </p>
 * <p>
 * This does not have a return value because there is no language
 * independent type that can refer to an interface or a
 * class.
 * </p>
 */

static void
jni_addRef(
  JNIEnv* env,
  jobject obj)
{
  /*
   * Declare return and temporary variables.
   */

  struct sidl_BaseInterface__object* _ior = NULL;
  struct sidl_BaseInterface__object *_ex = NULL;

  /*
   * Preprocess Java types and convert into IOR.
   */

  _ior = _get_ior(env, obj);

  /*
   * Call the IOR method through the EPV.
   */

  (*(_ior->d_epv->f_addRef))(
    _ior->d_object,
    &_ex);

  /*
   * Postprocess OUT, INOUT, returns, and exceptions.
   */

  if(_ex) {
    sidl_Java_CheckException(
      env,
      _ex,
      "sidl.RuntimeException",
      NULL);
    return;
  }
}

/*
 * Decrease by one the intrinsic reference count in the underlying
 * object, and delete the object if the reference is non-positive.
 * Objects in <code>sidl</code> have an intrinsic reference count.
 * Clients should call this method whenever they remove a
 * reference to an object or interface.
 */

static void
jni_deleteRef(
  JNIEnv* env,
  jobject obj)
{
  /*
   * Declare return and temporary variables.
   */

  struct sidl_BaseInterface__object* _ior = NULL;
  struct sidl_BaseInterface__object *_ex = NULL;

  /*
   * Preprocess Java types and convert into IOR.
   */

  _ior = _get_ior(env, obj);

  /*
   * Call the IOR method through the EPV.
   */

  (*(_ior->d_epv->f_deleteRef))(
    _ior->d_object,
    &_ex);

  /*
   * Postprocess OUT, INOUT, returns, and exceptions.
   */

  if(_ex) {
    sidl_Java_CheckException(
      env,
      _ex,
      "sidl.RuntimeException",
      NULL);
    return;
  }
}

/*
 * Return true if and only if <code>obj</code> refers to the same
 * object as this object.
 */

static jboolean
jni_isSame(
  JNIEnv* env,
  jobject obj,
  jobject _arg_iobj)
{
  /*
   * Declare return and temporary variables.
   */

  struct sidl_BaseInterface__object* _ior = NULL;
  struct sidl_BaseInterface__object* _tmp_iobj = (struct 
    sidl_BaseInterface__object*) NULL;
  sidl_bool _ior_res = FALSE;
  jboolean _res = JNI_FALSE;
  struct sidl_BaseInterface__object *_ex = NULL;

  /*
   * Preprocess Java types and convert into IOR.
   */

  _ior = _get_ior(env, obj);
  _tmp_iobj = (struct sidl_BaseInterface__object*) sidl_Java_J2I_ifc(env, 
    _arg_iobj, "sidl.BaseInterface", FALSE);JAVA_CHECK(env);

  /*
   * Call the IOR method through the EPV.
   */

  _ior_res = (*(_ior->d_epv->f_isSame))(
    _ior->d_object,
    _tmp_iobj,
    &_ex);

  /*
   * Postprocess OUT, INOUT, returns, and exceptions.
   */

  if(_ex) {
    sidl_Java_CheckException(
      env,
      _ex,
      "sidl.RuntimeException",
      NULL);

    return _res;
  }
  _res = (jboolean) _ior_res;

  return _res;
  JAVA_EXIT:

  return _res;
}

/*
 * Return whether this object is an instance of the specified type.
 * The string name must be the <code>sidl</code> type name.  This
 * routine will return <code>true</code> if and only if a cast to
 * the string type name would succeed.
 */

static jboolean
jni_isType(
  JNIEnv* env,
  jobject obj,
  jstring _arg_name)
{
  /*
   * Declare return and temporary variables.
   */

  struct sidl_BaseInterface__object* _ior = NULL;
  char* _tmp_name = (char*) NULL;
  sidl_bool _ior_res = FALSE;
  jboolean _res = JNI_FALSE;
  struct sidl_BaseInterface__object *_ex = NULL;

  /*
   * Preprocess Java types and convert into IOR.
   */

  _ior = _get_ior(env, obj);
  _tmp_name = sidl_Java_J2I_string(env, _arg_name);

  /*
   * Call the IOR method through the EPV.
   */

  _ior_res = (*(_ior->d_epv->f_isType))(
    _ior->d_object,
    _tmp_name,
    &_ex);

  /*
   * Postprocess OUT, INOUT, returns, and exceptions.
   */

  if(_ex) {
    sidl_Java_CheckException(
      env,
      _ex,
      "sidl.RuntimeException",
      NULL);

    return _res;
  }
  sidl_String_free(_tmp_name);
  _res = (jboolean) _ior_res;

  return _res;
}

/*
 * Return the meta-data about the class implementing this interface.
 */

static jobject
jni_getClassInfo(
  JNIEnv* env,
  jobject obj)
{
  /*
   * Declare return and temporary variables.
   */

  struct sidl_BaseInterface__object* _ior = NULL;
  struct sidl_ClassInfo__object* _ior_res = (struct sidl_ClassInfo__object*) 
    NULL;
  jobject _res = (jobject) NULL;
  struct sidl_BaseInterface__object *_ex = NULL;

  /*
   * Preprocess Java types and convert into IOR.
   */

  _ior = _get_ior(env, obj);

  /*
   * Call the IOR method through the EPV.
   */

  _ior_res = (*(_ior->d_epv->f_getClassInfo))(
    _ior->d_object,
    &_ex);

  /*
   * Postprocess OUT, INOUT, returns, and exceptions.
   */

  if(_ex) {
    sidl_Java_CheckException(
      env,
      _ex,
      "sidl.RuntimeException",
      NULL);

    return _res;
  }
  _res = sidl_Java_I2J_ifc(env, _ior_res, "sidl.ClassInfo", FALSE);JAVA_CHECK(
    env);

  return _res;
  JAVA_EXIT:

  return _res;
}

/*
 * Select and execute a method by name
 */

static void
jni__exec(
  JNIEnv* env,
  jobject obj,
  jstring _arg_methodName,
  jobject _arg_inArgs,
  jobject _arg_outArgs)
{
  /*
   * Declare return and temporary variables.
   */

  struct sidl_BaseInterface__object* _ior = NULL;
  char* _tmp_methodName = (char*) NULL;
  struct sidl_rmi_Call__object* _tmp_inArgs = (struct sidl_rmi_Call__object*) 
    NULL;
  struct sidl_rmi_Return__object* _tmp_outArgs = (struct 
    sidl_rmi_Return__object*) NULL;
  struct sidl_BaseInterface__object *_ex = NULL;

  /*
   * Preprocess Java types and convert into IOR.
   */

  _ior = _get_ior(env, obj);
  _tmp_methodName = sidl_Java_J2I_string(env, _arg_methodName);
  _tmp_inArgs = (struct sidl_rmi_Call__object*) sidl_Java_J2I_ifc(env, 
    _arg_inArgs, "sidl.rmi.Call", FALSE);JAVA_CHECK(env);
  _tmp_outArgs = (struct sidl_rmi_Return__object*) sidl_Java_J2I_ifc(env, 
    _arg_outArgs, "sidl.rmi.Return", FALSE);JAVA_CHECK(env);

  /*
   * Call the IOR method through the EPV.
   */

  (*(_ior->d_epv->f__exec))(
    _ior->d_object,
    _tmp_methodName,
    _tmp_inArgs,
    _tmp_outArgs,
    &_ex);

  /*
   * Postprocess OUT, INOUT, returns, and exceptions.
   */

  if(_ex) {
    sidl_Java_CheckException(
      env,
      _ex,
      "sidl.RuntimeException",
      NULL);
    return;
  }
  sidl_String_free(_tmp_methodName);
  JAVA_EXIT:
  return;
}
/*
 * Method to enable/disable method hooks invocation.
 */

static void
jni__set_hooks(
  JNIEnv* env,
  jobject obj,
  jboolean _arg_enable)
{
  /*
   * Declare return and temporary variables.
   */

  struct sidl_BaseInterface__object* _ior = NULL;
  sidl_bool _tmp_enable = FALSE;
  struct sidl_BaseInterface__object *_ex = NULL;

  /*
   * Preprocess Java types and convert into IOR.
   */

  _ior = _get_ior(env, obj);
  _tmp_enable = (sidl_bool) _arg_enable;

  /*
   * Call the IOR method through the EPV.
   */

  (*(_ior->d_epv->f__set_hooks))(
    _ior->d_object,
    _tmp_enable,
    &_ex);

  /*
   * Postprocess OUT, INOUT, returns, and exceptions.
   */

  if(_ex) {
    sidl_Java_CheckException(
      env,
      _ex,
      "sidl.RuntimeException",
      NULL);
    return;
  }
}

/**
 * Local utility function to extract the array pointer from the Java object.
 * Extract the d_array long data member and convert it to a pointer.
 */
static struct sidl_BaseInterface__array* sidl_BaseInterface__getptr(
JNIEnv* env,
jobject obj)
{
  void* ptr = NULL;
  static jfieldID s_array_field = NULL;

  if (s_array_field == NULL) {
    jclass cls = (*env)->GetObjectClass(env, obj);
    s_array_field = (*env)->GetFieldID(env, cls, "d_array", "J");
    (*env)->DeleteLocalRef(env, cls);
  }

  ptr = JLONG_TO_POINTER((*env)->GetLongField(env, obj, s_array_field));
  return (struct sidl_BaseInterface__array*) ptr;
}

/**
 * Local utility function to set the array pointer on the Java object.
 * Convert the pointer to a long value and set the d_array data member.
 */
static void sidl_BaseInterface__setptr(
JNIEnv* env,
jobject obj,
struct sidl_BaseInterface__array* array)
{
  static jfieldID s_array_field = NULL;

  if (s_array_field == NULL) {
    jclass cls = (*env)->GetObjectClass(env, obj);
    s_array_field = (*env)->GetFieldID(env, cls, "d_array", "J");
    (*env)->DeleteLocalRef(env, cls);
  }

  (*env)->SetLongField(env, obj, s_array_field, POINTER_TO_JLONG(array));
}

/**
 * Native routine to fetch the specified value from the array.  The
 * specified array index/indices must be lie between the array lower
 * upper bounds (inclusive).  Invalid indices will have unpredictable
 * (but almost certainly bad) results.
 */
static jobject sidl_BaseInterface__get(
JNIEnv* env,
jobject obj,
jint i,
jint j,
jint k,
jint l,
jint m,
jint n,
jint o)
{
  struct sidl_BaseInterface__array* array = sidl_BaseInterface__getptr(env, 
    obj);
  struct sidl_BaseInterface__object* value = NULL;
  struct sidl_BaseClass__object* bclass = NULL;
  jobject _res = NULL;
  struct sidl_BaseInterface__object *_ex = NULL, *_ex2 = NULL;
  int32_t a[7];
  a[0] = i;
  a[1] = j;
  a[2] = k;
  a[3] = l;
  a[4] = m;
  a[5] = n;
  a[6] = o;

  value = sidl_BaseInterface__array_get(array, a);
  bclass = sidl_BaseClass__cast(value, &_ex);
  if (value) {
    sidl_BaseInterface_deleteRef(value, &_ex2);
  }
  if(_ex) {
    sidl_Java_CheckException(
      env,
      _ex,
      "sidl.RuntimeException",
      NULL);

    return _res;
  }
  _ex = _ex2;
  if(_ex) {
    sidl_Java_CheckException(
      env,
      _ex,
      "sidl.RuntimeException",
      NULL);

    return _res;
  }
  _res = sidl_Java_I2J_ifc(env, bclass, "sidl.BaseInterface", FALSE);
  return _res;
}

/**
 * Native routine to set the specified value in the array.  The
 * specified array index/indices must be lie between the array lower
 * upper bounds (inclusive).  Invalid indices will have unpredictable
 * (but almost certainly bad) results.
 */
static void sidl_BaseInterface__set(
JNIEnv* env,
jobject obj,
jint i,
jint j,
jint k,
jint l,
jint m, 
jint n, 
jint o,
jobject value)
{
  struct sidl_BaseInterface__array* array = sidl_BaseInterface__getptr(env, 
    obj);

  sidl_BaseInterface vpointer = sidl_Java_J2I_cls(env, value, FALSE);
  int32_t a[7];
  a[0] = i;
  a[1] = j;
  a[2] = k;
  a[3] = l;
  a[4] = m;
  a[5] = n;
  a[6] = o;
  sidl_BaseInterface__array_set(array, a, vpointer);
}
/**
 * Native routine to reallocate data in the array.  The specified array
 * dimension and indices must match and be within valid ranges (e.g., the
 * upper bounds must be greater than or equal to lowe rbounds.  Invalid
 * indices will have unpredictable (but almost certainly bad) results.
 * This routine will deallocate the existing array data if it is not null.
 */
static void sidl_BaseInterface__reallocate(
JNIEnv* env,
jobject obj,
jint dim,
jarray lower,
jarray upper,
jboolean isRow)
{
  jint l[7];
  jint u[7];
  struct sidl_BaseInterface__array* array = NULL;
  struct sidl_BaseInterface__array* orig = sidl_BaseInterface__getptr(env,obj);
  int32_t i, lenl, lenu = 0;

  for(i=0; i < 7; ++i) {
    l[i] = 0;
    u[i] = 0;
  }
  lenl = (*env)->GetArrayLength(env, lower);
  lenu = (*env)->GetArrayLength(env, upper);


  sidl_BaseInterface__array_deleteRef(orig);
  (*env)->GetIntArrayRegion(env, lower, 0, lenl, (int32_t*)l);
  (*env)->GetIntArrayRegion(env, upper, 0, lenu, (int32_t*)u);


  if(isRow) 
    array = sidl_BaseInterface__array_createRow((int32_t) dim, (int32_t*) l, (
      int32_t*) u);
  else
    array = sidl_BaseInterface__array_createCol((int32_t) dim, (int32_t*) l, (
      int32_t*) u);


  sidl_BaseInterface__setptr(env, obj, array);
}

/**
 * 
 * Native function copies every element of an array to an array of the
 * same dimensionality, size, and type 
 * 
 */
static void sidl_BaseInterface__copy(
JNIEnv* env,
jobject obj,
jobject dest)
{
  struct sidl_BaseInterface__array* csrc = sidl_BaseInterface__getptr(env, obj);
  struct sidl_BaseInterface__array* cdest = sidl_BaseInterface__getptr(env, 
    dest);

  if(csrc && cdest) {
    sidl_BaseInterface__array_copy(csrc,cdest);
    } 

  }

/**
 * 
 * Native function slices arrays in various ways
 * 
 */
static jobject sidl_BaseInterface__slice(
JNIEnv* env,
jobject obj, 
jint dimen, 
jintArray numElem, 
jintArray srcStart, 
jintArray srcStride,
jintArray newStart)
{
  struct sidl_BaseInterface__array* array = sidl_BaseInterface__getptr(env, 
    obj);
  struct sidl_BaseInterface__array* ret_ptr = NULL;
  jobject ret_array = NULL;
  int cnumElem[7];
  int csrcStart[7];
  int csrcStride[7];
  int cnewStart[7]; 
  int i = 0; 
  for(i = 0; i < 7; ++i) {  /*Make sure the array are clean*/ 
    cnumElem[i] = 0;
    csrcStart[i] = 0;
    csrcStride[i] = 0;
    cnewStart[i] = 0;
    }

  if(numElem == NULL)
  return NULL;  /*If numElem is NULL, we need to return Null, that's bad.*/

  (*env)->GetIntArrayRegion(env, numElem, 0,
  (*env)->GetArrayLength(env, numElem), cnumElem);  

  if(srcStart != NULL)
  (*env)->GetIntArrayRegion(env, srcStart, 0, 
  (*env)->GetArrayLength(env, srcStart), csrcStart);  

  if(srcStride != NULL)
  (*env)->GetIntArrayRegion(env, srcStride, 0, 
  (*env)->GetArrayLength(env, srcStride), csrcStride);  

  if(newStart != NULL)
  (*env)->GetIntArrayRegion(env, newStart, 0, 
  (*env)->GetArrayLength(env, newStart), cnewStart);    


  if (array != NULL) {
    ret_ptr = sidl_BaseInterface__array_slice(array, dimen, cnumElem, csrcStart,
      csrcStride, cnewStart);
    }

  if(ret_ptr != NULL) {  
    ret_array = sidl_Java_I2J_new_array(env,ret_ptr, 
      "sidl.BaseInterface$Array");
    }

  return ret_array;
  }


/**
 * 
 * Native routine to decrement the current array reference count.
 * 
 */

/**
 * 
 * Native routine converts Java array of object to sidl array
 * I'm sorry it's so complex, but the nature of working with the
 * JNI is such that I couldn't think of anyway but a big case statement
 * to make this work efficently
 * 
 */
static void sidl_BaseInterface__fromArray(
JNIEnv* env,
jobject obj,
jobjectArray orray,
jint dim,
jintArray _upper,
jboolean isRow)
{
  int i,j,k,l,m,n,o;
  jint upper[7];
  jint lower[7] = {0,0,0,0,0,0,0};
  jclass exceptionClass = NULL;
  jintArray _lower = (*env)->NewIntArray(env, 7);
  (*env)->GetIntArrayRegion(env, _upper, 0, 7, upper);
  (*env)->SetIntArrayRegion(env, _lower, 0, 7, lower);
  sidl_BaseInterface__reallocate(env, obj, dim, _lower, _upper, isRow);
  (*env)->DeleteLocalRef(env, _lower);

  switch(dim) {
    case 1:
    for(i = 0; i <= upper[0]; ++i) {
      jobject tmp = (*env)->GetObjectArrayElement(env,orray, i);
      sidl_BaseInterface__set(env,obj,i,0,0,0,0,0,0,tmp);
      (*env)->DeleteLocalRef(env, tmp);
      }
    break;
    case 2:
    for(j = 0; j <= upper[0]; ++j) {
      jobjectArray orray1 = (*env)->GetObjectArrayElement(env,orray, j);
      for(i = 0; i <= upper[1]; ++i) {
        jobject tmp = (*env)->GetObjectArrayElement(env,orray1, i);
        sidl_BaseInterface__set(env,obj,j,i,0,0,0,0,0,tmp);
        (*env)->DeleteLocalRef(env, tmp);
        }
      (*env)->DeleteLocalRef(env, orray1);
      }
    break;
    case 3:
    for(k = 0; k <= upper[0]; ++k) {
      jobjectArray orray1 = (*env)->GetObjectArrayElement(env,orray, k);
      for(j = 0; j <= upper[1]; ++j) {
        jobjectArray orray2 = (*env)->GetObjectArrayElement(env,orray1, j);
        for(i = 0; i <= upper[2]; ++i) {
          jobject tmp = (*env)->GetObjectArrayElement(env,orray2, i);
          sidl_BaseInterface__set(env,obj,k,j,i,0,0,0,0,tmp);
          (*env)->DeleteLocalRef(env, tmp);
          }
        (*env)->DeleteLocalRef(env, orray2);
        }
      (*env)->DeleteLocalRef(env, orray1);
      }

    break;
    case 4:
    for(l = 0; l <= upper[0]; ++l) {
      jobjectArray orray1 = (*env)->GetObjectArrayElement(env,orray, l);
      for(k = 0; k <= upper[1]; ++k) {
        jobjectArray orray2 = (*env)->GetObjectArrayElement(env,orray1, k);
        for(j = 0; j <= upper[2]; ++j) {
          jobjectArray orray3 = (*env)->GetObjectArrayElement(env,orray2, j);
          for(i = 0; i <= upper[3]; ++i) {
            jobject tmp = (*env)->GetObjectArrayElement(env,orray3, i);
            sidl_BaseInterface__set(env,obj,l,k,j,i,0,0,0,tmp);
            (*env)->DeleteLocalRef(env, tmp);
            }
          (*env)->DeleteLocalRef(env, orray3);
          }
        (*env)->DeleteLocalRef(env, orray2);
        }   
      (*env)->DeleteLocalRef(env, orray1);
      }
    (*env)->DeleteLocalRef(env, orray);

    break;
    case 5:
    for(m = 0; m <= upper[0]; ++m) {
      jobjectArray orray1 = (*env)->GetObjectArrayElement(env,orray, m);   
      for(l = 0; l <= upper[1]; ++l) {
        jobjectArray orray2 = (*env)->GetObjectArrayElement(env,orray1, l);
        for(k = 0; k <= upper[2]; ++k) {
          jobjectArray orray3 = (*env)->GetObjectArrayElement(env,orray2, k);
          for(j = 0; j <= upper[3]; ++j) {
            jobjectArray orray4 = (*env)->GetObjectArrayElement(env,orray3, j);
            for(i = 0; i <= upper[4]; ++i) {
              jobject tmp = (*env)->GetObjectArrayElement(env,orray4, i);
              sidl_BaseInterface__set(env,obj,m,l,k,j,i,0,0,tmp);
              (*env)->DeleteLocalRef(env, tmp);
              }
            (*env)->DeleteLocalRef(env, orray4);
            }
          (*env)->DeleteLocalRef(env, orray3);
          }   
        (*env)->DeleteLocalRef(env, orray2);
        }
      (*env)->DeleteLocalRef(env, orray1);
      }
    (*env)->DeleteLocalRef(env, orray);

    break;
    case 6:
    for(n = 0; n <= upper[0]; ++n) {
      jobjectArray orray1 = (*env)->GetObjectArrayElement(env,orray, n);   
      for(m = 0; m <= upper[1]; ++m) {
        jobjectArray orray2 = (*env)->GetObjectArrayElement(env,orray1, m);   
        for(l = 0; l <= upper[2]; ++l) {
          jobjectArray orray3 = (*env)->GetObjectArrayElement(env,orray2, l);
          for(k = 0; k <= upper[3]; ++k) {
            jobjectArray orray4 = (*env)->GetObjectArrayElement(env,orray3, k);
            for(j = 0; j <= upper[4]; ++j) {
              jobjectArray orray5 = (*env)->GetObjectArrayElement(env,orray4, 
                j);
              for(i = 0; i <= upper[5]; ++i) {
                jobject tmp = (*env)->GetObjectArrayElement(env,orray5, i);
                sidl_BaseInterface__set(env,obj,n,m,l,k,j,i,0,tmp);
                (*env)->DeleteLocalRef(env, tmp);
                }
              (*env)->DeleteLocalRef(env, orray5);
              }
            (*env)->DeleteLocalRef(env, orray4);
            }   
          (*env)->DeleteLocalRef(env, orray3);
          }
        (*env)->DeleteLocalRef(env, orray2);
        }
      (*env)->DeleteLocalRef(env, orray1);
      }
    (*env)->DeleteLocalRef(env, orray);

    break;
    case 7:
    for(o = 0; o <= upper[0]; ++o) {
      jobjectArray orray1 = (*env)->GetObjectArrayElement(env,orray, o);   
      for(n = 0; n <= upper[1]; ++n) {
        jobjectArray orray2 = (*env)->GetObjectArrayElement(env,orray1, n);   
        for(m = 0; m <= upper[2]; ++m) {
          jobjectArray orray3 = (*env)->GetObjectArrayElement(env,orray2, m);   
          for(l = 0; l <= upper[3]; ++l) {
            jobjectArray orray4 = (*env)->GetObjectArrayElement(env,orray3, l);
            for(k = 0; k <= upper[4]; ++k) {
              jobjectArray orray5 = (*env)->GetObjectArrayElement(env,orray4, 
                k);
              for(j = 0; j <= upper[5]; ++j) {
                jobjectArray orray6 = (*env)->GetObjectArrayElement(env,orray5, 
                  j);
                for(i = 0; i <= upper[6]; ++i) {
                  jobject tmp = (*env)->GetObjectArrayElement(env,orray6, i);
                  sidl_BaseInterface__set(env,obj,o,n,m,l,k,j,i,tmp);
                  (*env)->DeleteLocalRef(env, tmp);
                  }
                (*env)->DeleteLocalRef(env, orray6);
                }
              (*env)->DeleteLocalRef(env, orray5);
              }   
            (*env)->DeleteLocalRef(env, orray4);
            }
          (*env)->DeleteLocalRef(env, orray3);
          }
        (*env)->DeleteLocalRef(env, orray2);
        }
      (*env)->DeleteLocalRef(env, orray1);
      }
    (*env)->DeleteLocalRef(env, orray);
    break;
    default:
    exceptionClass = (*env)->FindClass(env, 
      "java/lang/IllegalArgumentException");
    (*env)->ThrowNew(env, exceptionClass,"JNI:_fromArray: Array dimensions must be between 1-7!");
    }
  }
/*
 * Register JNI methods with the Java JVM.
 */

void sidl_BaseInterface__register(JNIEnv* env)
{
  JNINativeMethod methods[8];
  jclass cls;

  methods[0].name      = "_connect_remote_ior";
  methods[0].signature = "(Ljava/lang/String;)J";
  methods[0].fnPtr     = (void *)jni__connect_remote_ior;
  methods[1].name      = "_exec";
  methods[1].signature = "(Ljava/lang/String;Lsidl/rmi/Call;Lsidl/rmi/Return;)V";
  methods[1].fnPtr     = (void *)jni__exec;
  methods[2].name      = "_set_hooks";
  methods[2].signature = "(Z)V";
  methods[2].fnPtr     = (void *)jni__set_hooks;
  methods[3].name      = "addRef";
  methods[3].signature = "()V";
  methods[3].fnPtr     = (void *)jni_addRef;
  methods[4].name      = "deleteRef";
  methods[4].signature = "()V";
  methods[4].fnPtr     = (void *)jni_deleteRef;
  methods[5].name      = "isSame";
  methods[5].signature = "(Lsidl/BaseInterface;)Z";
  methods[5].fnPtr     = (void *)jni_isSame;
  methods[6].name      = "isType";
  methods[6].signature = "(Ljava/lang/String;)Z";
  methods[6].fnPtr     = (void *)jni_isType;
  methods[7].name      = "getClassInfo";
  methods[7].signature = "()Lsidl/ClassInfo;";
  methods[7].fnPtr     = (void *)jni_getClassInfo;


  cls = (*env)->FindClass(env, "sidl/BaseInterface$Wrapper");
  if (cls) {
    (*env)->RegisterNatives(env, cls, methods, 8);
    (*env)->DeleteLocalRef(env, cls);
  }
  {
    JNINativeMethod methods1[6];
    jclass cls1;

    methods1[0].name      = "_get";
    methods1[0].signature = "(IIIIIII)Lsidl/BaseInterface$Wrapper;";
    methods1[0].fnPtr     = (void *)sidl_BaseInterface__get;
    methods1[1].name      = "_set";
    methods1[1].signature = "(IIIIIIILsidl/BaseInterface;)V";
    methods1[1].fnPtr     = (void *)sidl_BaseInterface__set;
    methods1[2].name      = "_reallocate";
    methods1[2].signature = "(I[I[IZ)V";
    methods1[2].fnPtr     = (void *)sidl_BaseInterface__reallocate;
    methods1[3].name      = "_copy";
    methods1[3].signature = "(Lsidl/BaseInterface$Array;)V";
    methods1[3].fnPtr     = (void *)sidl_BaseInterface__copy;  
    methods1[4].name      = "_slice";
    methods1[4].signature = "(I[I[I[I[I)Lsidl/BaseInterface$Array;";
    methods1[4].fnPtr     = (void *)sidl_BaseInterface__slice;    
    methods1[5].name      = "_fromArray";
    methods1[5].signature = "([Ljava/lang/Object;I[IZ)V";
    methods1[5].fnPtr     = (void *)sidl_BaseInterface__fromArray;


    cls1 = (*env)->FindClass(env, "sidl/BaseInterface$Array");
    if (cls1) {
      (*env)->RegisterNatives(env, cls1, methods1, 6);
      (*env)->DeleteLocalRef(env, cls1);
    }
  }
}
