/*
 * File:          sidl_Resolve_Stub.c
 * Symbol:        sidl.Resolve-v0.9.17
 * Symbol Type:   enumeration
 * Babel Version: 2.0.0 (Revision: 7437  trunk)
 * Release:       $Name:  $
 * Revision:      @(#) $Id: $
 * Description:   Client-side glue code for sidl.Resolve
 * 
 * Copyright (c) 2000-2002, Lawrence Livermore National Security, LLC.
 * Produced at the Lawrence Livermore National Laboratory.
 * Written by the Components Team <components@llnl.gov>
 * All rights reserved.
 * 
 * This file is part of Babel. For more information, see
 * http://www.llnl.gov/CASC/components/. Please read the COPYRIGHT file
 * for Our Notice and the LICENSE file for the GNU Lesser General Public
 * License.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License (as published by
 * the Free Software Foundation) version 2.1 dated February 1999.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms and
 * conditions of the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * WARNING: Automatically generated; changes will be lost
 */

#include "sidl_Resolve.h"
#ifndef included_sidl_long_IOR_h
#include "sidl_long_IOR.h"
#endif
#include <stddef.h>

/**
 * Create a contiguous array of the given dimension with specified
 * index bounds in column-major order. This array
 * owns and manages its data.
 */
struct sidl_Resolve__array*
sidl_Resolve__array_createCol(
  int32_t       dimen,
  const int32_t lower[],
  const int32_t upper[])
{
  return (struct sidl_Resolve__array*)sidl_long__array_createCol(dimen, lower, 
    upper);
}

/**
 * Create a contiguous array of the given dimension with specified
 * index bounds in row-major order. This array
 * owns and manages its data.
 */
struct sidl_Resolve__array*
sidl_Resolve__array_createRow(
  int32_t       dimen,
  const int32_t lower[],
  const int32_t upper[])
{
  return (struct sidl_Resolve__array*)sidl_long__array_createRow(dimen, lower, 
    upper);
}

/**
 * Create a contiguous one-dimensional array with a lower index
 * of 0 and an upper index of len-1. This array
 * owns and manages its data.
 */
struct sidl_Resolve__array*
sidl_Resolve__array_create1d(int32_t len)
{
  return (struct sidl_Resolve__array*)sidl_long__array_create1d(len);
}

/**
 * Create a dense one-dimensional vector with a lower
 * index of 0 and an upper index of len-1. The initial data for this
 * new array is copied from data. This will increment the reference
 * count of each non-NULL object/interface reference in data.
 * 
 * This array owns and manages its data.
 */
struct sidl_Resolve__array*
sidl_Resolve__array_create1dInit(
  int32_t len, 
  int64_t* data)
{
  return (struct sidl_Resolve__array*)sidl_long__array_create1dInit(len, (
    int64_t*)data);
}

/**
 * Create a contiguous two-dimensional array in column-major
 * order with a lower index of (0,0) and an upper index of
 * (m-1,n-1). This array owns and manages its data.
 */
struct sidl_Resolve__array*
sidl_Resolve__array_create2dCol(int32_t m, int32_t n)
{
  return (struct sidl_Resolve__array*)sidl_long__array_create2dCol(m, n);
}

/**
 * Create a contiguous two-dimensional array in row-major
 * order with a lower index of (0,0) and an upper index of
 * (m-1,n-1). This array owns and manages its data.
 */
struct sidl_Resolve__array*
sidl_Resolve__array_create2dRow(int32_t m, int32_t n)
{
  return (struct sidl_Resolve__array*)sidl_long__array_create2dRow(m, n);
}

/**
 * Create an array that uses data (memory) from another
 * source. The initial contents are determined by the
 * data being borrowed.
 * The borrowed data must be a pointer to int64_t.
 */
struct sidl_Resolve__array*
sidl_Resolve__array_borrow(
  int64_t * firstElement,
  int32_t       dimen,
  const int32_t lower[],
  const int32_t upper[],
  const int32_t stride[])
{
  return (struct sidl_Resolve__array*)sidl_long__array_borrow(
    firstElement, dimen, lower, upper, stride);
}

/**
 * If array is borrowed, allocate a new self-sufficient
 * array and copy the borrowed array into the new array;
 * otherwise, increment the reference count and return
 * the array passed in. Use this whenever you want to
 * make a copy of a method argument because arrays
 * passed into methods aren't guaranteed to exist after
 * the method call.
 */
struct sidl_Resolve__array*
sidl_Resolve__array_smartCopy(
  struct sidl_Resolve__array *array)
{
  return (struct sidl_Resolve__array*)
    sidl_long__array_smartCopy((struct sidl_long__array *)array);
}

/**
 * Increment the array's internal reference count by one.
 */
void
sidl_Resolve__array_addRef(
  struct sidl_Resolve__array* array)
{
  sidl_long__array_addRef((struct sidl_long__array *)array);
}

/**
 * Decrement the array's internal reference count by one.
 * If the reference count goes to zero, destroy the array.
 */
void
sidl_Resolve__array_deleteRef(
  struct sidl_Resolve__array* array)
{
  sidl_long__array_deleteRef((struct sidl_long__array *)array);
}

/**
 * Retrieve element i1 of a(n) 1-dimensional array.
 */
enum sidl_Resolve__enum
sidl_Resolve__array_get1(
  const struct sidl_Resolve__array* array,
  const int32_t i1)
{
  return (enum sidl_Resolve__enum)
    sidl_long__array_get1((const struct sidl_long__array *)array
    , i1);
}

/**
 * Retrieve element (i1,i2) of a(n) 2-dimensional array.
 */
enum sidl_Resolve__enum
sidl_Resolve__array_get2(
  const struct sidl_Resolve__array* array,
  const int32_t i1,
  const int32_t i2)
{
  return (enum sidl_Resolve__enum)
    sidl_long__array_get2((const struct sidl_long__array *)array
    , i1, i2);
}

/**
 * Retrieve element (i1,i2,i3) of a(n) 3-dimensional array.
 */
enum sidl_Resolve__enum
sidl_Resolve__array_get3(
  const struct sidl_Resolve__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3)
{
  return (enum sidl_Resolve__enum)
    sidl_long__array_get3((const struct sidl_long__array *)array
    , i1, i2, i3);
}

/**
 * Retrieve element (i1,i2,i3,i4) of a(n) 4-dimensional array.
 */
enum sidl_Resolve__enum
sidl_Resolve__array_get4(
  const struct sidl_Resolve__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4)
{
  return (enum sidl_Resolve__enum)
    sidl_long__array_get4((const struct sidl_long__array *)array
    , i1, i2, i3, i4);
}

/**
 * Retrieve element (i1,i2,i3,i4,i5) of a(n) 5-dimensional array.
 */
enum sidl_Resolve__enum
sidl_Resolve__array_get5(
  const struct sidl_Resolve__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5)
{
  return (enum sidl_Resolve__enum)
    sidl_long__array_get5((const struct sidl_long__array *)array
    , i1, i2, i3, i4, i5);
}

/**
 * Retrieve element (i1,i2,i3,i4,i5,i6) of a(n) 6-dimensional array.
 */
enum sidl_Resolve__enum
sidl_Resolve__array_get6(
  const struct sidl_Resolve__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5,
  const int32_t i6)
{
  return (enum sidl_Resolve__enum)
    sidl_long__array_get6((const struct sidl_long__array *)array
    , i1, i2, i3, i4, i5, i6);
}

/**
 * Retrieve element (i1,i2,i3,i4,i5,i6,i7) of a(n) 7-dimensional array.
 */
enum sidl_Resolve__enum
sidl_Resolve__array_get7(
  const struct sidl_Resolve__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5,
  const int32_t i6,
  const int32_t i7)
{
  return (enum sidl_Resolve__enum)
    sidl_long__array_get7((const struct sidl_long__array *)array
    , i1, i2, i3, i4, i5, i6, i7);
}

/**
 * Retrieve element indices of an n-dimensional array.
 * indices is assumed to have the right number of elements
 * for the dimension of array.
 */
enum sidl_Resolve__enum
sidl_Resolve__array_get(
  const struct sidl_Resolve__array* array,
  const int32_t indices[])
{
  return (enum sidl_Resolve__enum)
    sidl_long__array_get((const struct sidl_long__array *)array, indices);
}

/**
 * Set element i1 of a(n) 1-dimensional array to value.
 */
void
sidl_Resolve__array_set1(
  struct sidl_Resolve__array* array,
  const int32_t i1,
  enum sidl_Resolve__enum const value)
{
  sidl_long__array_set1((struct sidl_long__array *)array
  , i1, (int64_t)value);
}

/**
 * Set element (i1,i2) of a(n) 2-dimensional array to value.
 */
void
sidl_Resolve__array_set2(
  struct sidl_Resolve__array* array,
  const int32_t i1,
  const int32_t i2,
  enum sidl_Resolve__enum const value)
{
  sidl_long__array_set2((struct sidl_long__array *)array
  , i1, i2, (int64_t)value);
}

/**
 * Set element (i1,i2,i3) of a(n) 3-dimensional array to value.
 */
void
sidl_Resolve__array_set3(
  struct sidl_Resolve__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  enum sidl_Resolve__enum const value)
{
  sidl_long__array_set3((struct sidl_long__array *)array
  , i1, i2, i3, (int64_t)value);
}

/**
 * Set element (i1,i2,i3,i4) of a(n) 4-dimensional array to value.
 */
void
sidl_Resolve__array_set4(
  struct sidl_Resolve__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  enum sidl_Resolve__enum const value)
{
  sidl_long__array_set4((struct sidl_long__array *)array
  , i1, i2, i3, i4, (int64_t)value);
}

/**
 * Set element (i1,i2,i3,i4,i5) of a(n) 5-dimensional array to value.
 */
void
sidl_Resolve__array_set5(
  struct sidl_Resolve__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5,
  enum sidl_Resolve__enum const value)
{
  sidl_long__array_set5((struct sidl_long__array *)array
  , i1, i2, i3, i4, i5, (int64_t)value);
}

/**
 * Set element (i1,i2,i3,i4,i5,i6) of a(n) 6-dimensional array to value.
 */
void
sidl_Resolve__array_set6(
  struct sidl_Resolve__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5,
  const int32_t i6,
  enum sidl_Resolve__enum const value)
{
  sidl_long__array_set6((struct sidl_long__array *)array
  , i1, i2, i3, i4, i5, i6, (int64_t)value);
}

/**
 * Set element (i1,i2,i3,i4,i5,i6,i7) of a(n) 7-dimensional array to value.
 */
void
sidl_Resolve__array_set7(
  struct sidl_Resolve__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5,
  const int32_t i6,
  const int32_t i7,
  enum sidl_Resolve__enum const value)
{
  sidl_long__array_set7((struct sidl_long__array *)array
  , i1, i2, i3, i4, i5, i6, i7, (int64_t)value);
}

/**
 * Set element indices of an n-dimensional array to value.indices is assumed to have the right number of elements
 * for the dimension of array.
 */
void
sidl_Resolve__array_set(
  struct sidl_Resolve__array* array,
  const int32_t indices[],
  enum sidl_Resolve__enum const value)
{
  sidl_long__array_set((struct sidl_long__array *)array, indices, (
    int64_t)value);
}

/**
 * Return the dimension of array. If the array pointer is
 * NULL, zero is returned.
 */
int32_t
sidl_Resolve__array_dimen(
  const struct sidl_Resolve__array* array)
{
  return sidl_long__array_dimen((struct sidl_long__array *)array);
}

/**
 * Return the lower bound of dimension ind.
 * If ind is not a valid dimension, 0 is returned.
 * The valid range for ind is from 0 to dimen-1.
 */
int32_t
sidl_Resolve__array_lower(
  const struct sidl_Resolve__array* array,
  const int32_t ind)
{
  return sidl_long__array_lower((struct sidl_long__array *)array, ind);
}

/**
 * Return the upper bound of dimension ind.
 * If ind is not a valid dimension, -1 is returned.
 * The valid range for ind is from 0 to dimen-1.
 */
int32_t
sidl_Resolve__array_upper(
  const struct sidl_Resolve__array* array,
  const int32_t ind)
{
  return sidl_long__array_upper((struct sidl_long__array *)array, ind);
}

/**
 * Return the length of dimension ind.
 * If ind is not a valid dimension, -1 is returned.
 * The valid range for ind is from 0 to dimen-1.
 */
int32_t
sidl_Resolve__array_length(
  const struct sidl_Resolve__array* array,
  const int32_t ind)
{
  return sidl_long__array_length((struct sidl_long__array *)array, ind);
}

/**
 * Return the stride of dimension ind.
 * If ind is not a valid dimension, 0 is returned.
 * The valid range for ind is from 0 to dimen-1.
 */
int32_t
sidl_Resolve__array_stride(
  const struct sidl_Resolve__array* array,
  const int32_t ind)
{
  return sidl_long__array_stride((struct sidl_long__array *)array, ind);
}

/**
 * Return a true value iff the array is a contiguous
 * column-major ordered array. A NULL array argument
 * causes 0 to be returned.
 */
int
sidl_Resolve__array_isColumnOrder(
  const struct sidl_Resolve__array* array)
{
  return sidl_long__array_isColumnOrder((struct sidl_long__array *)array);
}

/**
 * Return a true value iff the array is a contiguous
 * row-major ordered array. A NULL array argument
 * causes 0 to be returned.
 */
int
sidl_Resolve__array_isRowOrder(
  const struct sidl_Resolve__array* array)
{
  return sidl_long__array_isRowOrder((struct sidl_long__array *)array);
}

/**
 * Copy the contents of one array (src) to a second array
 * (dest). For the copy to take place, both arrays must
 * exist and be of the same dimension. This method will
 * not modify dest's size, index bounds, or stride; only
 * the array element values of dest may be changed by
 * this function. No part of src is ever changed by copy.
 * 
 * On exit, dest[i][j][k]... = src[i][j][k]... for all
 * indices i,j,k...  that are in both arrays. If dest and
 * src have no indices in common, nothing is copied. For
 * example, if src is a 1-d array with elements 0-5 and
 * dest is a 1-d array with elements 2-3, this function
 * will make the following assignments:
 *   dest[2] = src[2],
 *   dest[3] = src[3].
 * The function copied the elements that both arrays have
 * in common.  If dest had elements 4-10, this function
 * will make the following assignments:
 *   dest[4] = src[4],
 *   dest[5] = src[5].
 */
void
sidl_Resolve__array_copy(
  const struct sidl_Resolve__array* src,
  struct sidl_Resolve__array* dest)
{
  sidl_long__array_copy((const struct sidl_long__array *)src,
                        (struct sidl_long__array *)dest);
}

/**
 * Create a sub-array of another array. This resulting
 * array shares data with the original array. The new
 * array can be of the same dimension or potentially
 * less assuming the original array has dimension
 * greater than 1.  If you are removing dimension,
 * indicate the dimensions to remove by setting
 * numElem[i] to zero for any dimension i wthat should
 * go away in the new array.  The meaning of each
 * argument is covered below.
 * 
 * src       the array to be created will be a subset
 *           of this array. If this argument is NULL,
 *           NULL will be returned. The array returned
 *           borrows data from src, so modifying src or
 *           the returned array will modify both
 *           arrays.
 * 
 * dimen     this argument must be greater than zero
 *           and less than or equal to the dimension of
 *           src. An illegal value will cause a NULL
 *           return value.
 * 
 * numElem   this specifies how many elements from src
 *           should be taken in each dimension. A zero
 *           entry indicates that the dimension should
 *           not appear in the new array.  This
 *           argument should be an array with an entry
 *           for each dimension of src.  Passing NULL
 *           here will cause NULL to be returned.  If
 *           srcStart[i] + numElem[i]*srcStride[i] is
 *           greater than upper[i] for src or if
 *           srcStart[i] + numElem[i]*srcStride[i] is
 *           less than lower[i] for src, NULL will be
 *           returned.
 * 
 * srcStart  this array holds the coordinates of the
 *           first element of the new array. If this
 *           argument is NULL, the first element of src
 *           will be the first element of the new
 *           array. If non-NULL, this argument should
 *           be an array with an entry for each
 *           dimension of src.  If srcStart[i] is less
 *           than lower[i] for the array src, NULL will
 *           be returned.
 * 
 * srcStride this array lets you specify the stride
 *           between elements in each dimension of
 *           src. This stride is relative to the
 *           coordinate system of the src array. If
 *           this argument is NULL, the stride is taken
 *           to be one in each dimension.  If non-NULL,
 *           this argument should be an array with an
 *           entry for each dimension of src.
 * 
 * newLower  this argument is like lower in a create
 *           method. It sets the coordinates for the
 *           first element in the new array.  If this
 *           argument is NULL, the values indicated by
 *           srcStart will be used. If non-NULL, this
 *           should be an array with dimen elements.
 */
struct sidl_Resolve__array*
sidl_Resolve__array_slice(
  struct sidl_Resolve__array* src,
  int32_t        dimen,
  const int32_t  numElem[],
  const int32_t  *srcStart,
  const int32_t  *srcStride,
  const int32_t  *newStart)
{
  return (struct sidl_Resolve__array*)
    sidl_long__array_slice((struct sidl_long__array *)src,
                           dimen, numElem, srcStart, srcStride, newStart);
}

/**
 * If necessary, convert a general matrix into a matrix
 * with the required properties. This checks the
 * dimension and ordering of the matrix.  If both these
 * match, it simply returns a new reference to the
 * existing matrix. If the dimension of the incoming
 * array doesn't match, it returns NULL. If the ordering
 * of the incoming array doesn't match the specification,
 * a new array is created with the desired ordering and
 * the content of the incoming array is copied to the new
 * array.
 * 
 * The ordering parameter should be one of the constants
 * defined in enum sidl_array_ordering
 * (e.g. sidl_general_order, sidl_column_major_order, or
 * sidl_row_major_order). If you specify
 * sidl_general_order, this routine will only check the
 * dimension because any matrix is sidl_general_order.
 * 
 * The caller assumes ownership of the returned reference
 * unless it's NULL.
 */
struct sidl_Resolve__array*
sidl_Resolve__array_ensure(
  struct sidl_Resolve__array* src,
  int32_t dimen,
  int     ordering)
{
  return (struct sidl_Resolve__array*)
    sidl_long__array_ensure((struct sidl_long__array *)src, dimen, ordering);
}

